#include <wx/wx.h>
#include <wx/listctrl.h>
#include <wx/event.h>
#include <sys/time.h>
#include <wx/spinctrl.h>
#include <wx/listbox.h>
#include "guitypes.h"
#include "image.h"

#ifndef CAMERA_DIALOG_H
#define CAMERA_DIALOG_H

/** Dialog for setting up the intrinsic properties of cameras.    
*/
class CameraDialog:public wxDialog{
  wxComboBox * cameraCombo,* modeCombo,* formatCombo;
  wxCheckBox * currentButton;
  wxSpinCtrl * nimages,* every;
  wxButton * grab, * removeButton, *forceButton;
  wxListBox * cameraList;
  wxTextCtrl * textctrl[9];
  int dialogChangingText;
 public:
  DECLARE_DYNAMIC_CLASS(CameraDialog)
    CameraDialog(wxWindow * parent=0,wxWindowID id=-1);

  void AddNewProfile(wxString &str,
		     double fx=1,double fy=1,
		     double px=0,double py=0);
  void OnForce(wxCommandEvent & event);
  void OnClose(wxCommandEvent & event);
  void OnOK(wxCommandEvent & event);
  void OnCurrent(wxCommandEvent & event);
  void OnNew(wxCommandEvent & event);
  void OnRemove(wxCommandEvent & event);
  void OnCameraChanged(wxCommandEvent & event);
  void OnCameraDoubleClick(wxCommandEvent & event);
  void OnIdle(wxIdleEvent & event);
  void OnTextCtrlChanged(wxCommandEvent & event);
  void UpdateDialog();
  DECLARE_EVENT_TABLE();
};


#endif
