#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef HEAP_H
#define HEAP_H

#ifdef MATLAB
#include <mex.h>
#endif

void * the_malloc(size_t size);
void   the_free(void *);

typedef struct HEAP_ELEMENT_T{
    int node;
    double value;
}HeapElement;

class Heap
{
    
 public:
    int * indices;
    HeapElement * data;
    int n;
  int max;
  Heap(int max);
  ~Heap();
  
  void siftup(int i);
  void siftDown(int i);
  void siftDown2(int i);
  int remove(double *v);
  void update(int noe,double val,int usemax=0);
  void removeAll();
  int peek();
  int insert(int node,double val);
  int exists(int node);
  double get(int node);

  void print();
  void checkHeapProperty(char * s=0);
  void check(char * s);
  int getSize(){return n;}
  float getWeight(int node);
};
#endif



