#include "image.h"
#include "matrix.h"

#ifndef IMAGE_UTILS_H
#define IMAGE_UTILS_H

template <class T>
Image8 colorSeg(Image<T> & image,Image<T> & color);

template <class T>
Image<T> applyHomography(Image<T> im,
			 Matrix & H,
			 double minx,
			 double maxx,
			 double miny,
			 double maxy);
void findBounds(Image8 & im1,Matrix & H1,
		double & minx,double & maxx);
void findBounds(Image8 & im1,Matrix & H1,
		Image8 & im2,Matrix & H2,
		double & minx,double & maxx,
		double & miny,double & maxy);
int rectify(Matrix & Po1,Matrix & Po2,
	    Matrix & T1,Matrix & T2,Matrix & Pn1,Matrix & Pn2);
int rectify(Matrix & intr1,Matrix & extr1,Matrix & intr2,Matrix & extr2,
	    Matrix & T1,Matrix & T2,Matrix & Pn1,Matrix & Pn2);

Imagef gaussFilt(int hs,double sdx,double sdy);
Imagef getCorners(Imagef & im,int hs,double thresh);
void suppress(Imagef & im,int hs=5);
Imagef harris(Imagef & im,double sigma);

template <class T>
Image<T> removeDistortion(Image<T> & image,Matrix & intr,Matrix & dist);

Imagef gaussFilt(int hs,double sdx,double sdy);

#endif
