#ifndef MI_H
#define MI_H

#include"general.h"

struct mi_ray
{
  double origin[2];
  int axis;
  list<segment> segments;
  
  line project(const double cam[4][4]);
  void unproject(const double cam[4][4],const line &,int res);
  void check(int res);
  double intersect_point(double,double);
  bool inside(double);
  segment * nearest(double);
};

class mi_grid
{
  public:
    mi_grid(int res);
    ~mi_grid(){delete[] rays[0];delete[] rays[1];delete[] rays[2];};
    void intersect(bitmap,const double cam[4][4]);
    void render(void triangle(double *,double *,double *));
    void cleanup();
    void fixpoint(int x,int y,int z);
    
    mi_ray *rays[3];
    int res;
    int bad_incount1;
    int bad_incount2;
};

class mi_cube
{
  public:
    mi_cube(mi_grid *g,int x,int y,int z);
    void render(void triangle(double *,double *,double *));

    int in[8];
    double intersect[12][3];
    
    double X0;
    double Y0;
    double Z0;
    double X1;
    double Y1;
    double Z1;
};

void makecubetable();

#endif
