#include <stdio.h>
#include <stdlib.h>
#include "chart.h"
#include "plugin_defines.h"
#include <wx/wx.h>
#include <wx/spinctrl.h>
#include "simplify.h"
wxSpinCtrl * percentRemove=0;
wxPanel * panel=0;

extern "C" const char *  getName(){
  return "QEM";
}
extern "C" const char *  getInfo(){
  return "Simplify the original mesh using Garland and Heckberts Algorithm";
}
extern "C" int getType(){
  return GEOMPLUGIN_OPERATION_TYPE;
}
extern "C" int apply(Chart ** charts,int * ncharts){
  //Make sure there is only 1 chart
  if(*ncharts>1)
    return GEOMPLUGIN_RESTORE_BIT | GEOMPLUGIN_APPLY_AGAIN_BIT;
  else if(*ncharts==1)
    simplify((*charts)[0],percentRemove->GetValue());
  return 0;
}

extern "C" const void * getPanel(wxWindow * parent){
  printf("getting panel\n");
  panel = new wxPanel(parent);
  printf("%p\n",panel);
  wxStaticBoxSizer * vertical =
    new wxStaticBoxSizer(new wxStaticBox(panel,-1,wxT("")),
			 wxVERTICAL);
  wxStaticBoxSizer * sizer = new wxStaticBoxSizer(new wxStaticBox(panel,-1,wxT("")),
						  wxVERTICAL);
  printf("got sizer %p\n",sizer);
  percentRemove=new wxSpinCtrl(panel,-1);
  sizer->Add(new wxStaticText(panel,-1,wxT("% remove")),0);
  sizer->Add(percentRemove);
  
  vertical->Add(new wxStaticText(panel,0,wxT("Choose the \npercentage \n of vertices to\n remove"),
				 wxDefaultPosition));
  vertical->Add(sizer,0,wxGROW);
  panel->SetSizer(vertical);
  percentRemove->SetRange(1,99);
  percentRemove->SetValue(70);
  printf("done getting panel\n");
  return panel;
}
