#include <stdio.h>
#include <stdlib.h>
#include "chart.h"
#include "matrix.h"
#include "texgen.h"
#include "plugin_defines.h"

extern Vec3f scale;
extern Vec3f trans;

extern "C" const char *  getName(){
  return "Add Stick";
}
extern "C" const int  getType(){
  return TEXPLUGIN_OTHER_TYPE;
}
extern "C" const char *  getInfo(){
  return "Add stick geometry";
}
extern "C" int apply(Chart ** charts,int * ncharts){
  Vec3f tr=trans*-1;
  Vec3f sc(1.0/scale.x,1.0/scale.y,1.0/scale.z);
  Chart * newCharts = new Chart[*ncharts+1];
  for(int i=0;i<(*ncharts);i++){
    newCharts[i]=(*charts)[i];
  }
  char fname[1024];
  snprintf(fname,1024,"%s/.capsys/stick.obj",getenv("HOME"));
  newCharts[*ncharts].loadobj(fname);
  snprintf(fname,1024,"%s/.capsys/stick_sc_tr",getenv("HOME"));
  FILE * f=fopen(fname,"rb");
  Vec3f fsc(1,1,1);
  Vec3f ftr(0,0,0);
  if(f){
    fread(&(fsc.data),sizeof(Vec3f),1,f);
    fread(&(ftr.data),sizeof(Vec3f),1,f);
    fclose(f);
  }

  for(int i=0;i<newCharts[*ncharts].nvert;i++){
    newCharts[*ncharts].vert[i]+=newCharts[*ncharts].norm[i]*0.005;

    newCharts[*ncharts].vert[i].x*=(fsc.x);
    newCharts[*ncharts].vert[i].y*=(fsc.y);
    newCharts[*ncharts].vert[i].z*=(fsc.z);
    newCharts[*ncharts].vert[i]+=(ftr);

    newCharts[*ncharts].vert[i]+=(tr);
    newCharts[*ncharts].vert[i].x*=(sc.x);
    newCharts[*ncharts].vert[i].y*=(sc.y);
    newCharts[*ncharts].vert[i].z*=(sc.z);
    newCharts[*ncharts].tc[i]=Vec2f(0,0);//reset tex coords
  }
  delete [] (*charts);
  *(charts)=newCharts;
  (*ncharts)++;
  printf("Scale is %f %f %f\n",scale.x,scale.y,scale.z);
  return 0;
}
extern "C" const void * getPanel(void * v){
  return 0;
}
