#include <stdio.h>
#include <stdlib.h>
#include "chart.h"
#include <wx/wx.h>
#include "matrix.h"
#include "texgen.h"
#include "plugin_defines.h"
#include <vector>
#include <map>
#include <ext/hash_map>
#include "vec.h"
//using namespace std;
using namespace ::__gnu_cxx;

//a chart and polygon index...why not call choly
//its really a tuple, so it could be chouply, chouple
struct choly{
public:
  int chart;
  int poly;
  choly(){
    chart=-1;
    poly=-1;
  }
  choly(int c,int p){
    chart=c;
    poly=p;
  }
};

struct this_is_stupid{
  bool operator()(const Vec3f & v1,const Vec3f & v2){
    return ((v1-v2).len())<10e-10;
  }
};

struct the_hash{
  size_t operator()(const Vec3f & v1) const{
    return (size_t)(65537*(v1.x+2*v1.y+4*v1.z));
  }
};

typedef vector <choly> cholyvec; 
typedef hash_map <Vec3f,cholyvec,the_hash,this_is_stupid> vert2cholyvec;

void getUniqueVert(Chart * charts,int ncharts,
		   vert2cholyvec & v2c)
{
  int nvert=0;
  v2c.clear();
  for(int i=0;i<ncharts;i++){
    printf("doing chart %d, of %d\n",i,charts[i].nvert);
    for(int j=0;j<charts[i].npoly;j++){
      v2c[charts[i].vert[charts[i].poly[j][0]]].push_back(choly(i,j));
      v2c[charts[i].vert[charts[i].poly[j][1]]].push_back(choly(i,j));
      v2c[charts[i].vert[charts[i].poly[j][2]]].push_back(choly(i,j));
    }
    printf("%d v2c.size() %d\n",i,v2c.size());
  }
  printf("v2c.size() %d\n",v2c.size());
}

extern "C" const char *  getName(){
  return "Border Triangles";
}
extern "C" const int  getType(){
  return TEXPLUGIN_OTHER_TYPE;
}
extern "C" const char *  getInfo(){
  return "Duplicate triangles on the border of charts";
}
extern "C" int apply(Chart ** charts,int * ncharts){
  if(*ncharts>1){
    vert2cholyvec v2c;
    hash_map<Vec3f,int,the_hash,this_is_stupid> v2i;
    
    getUniqueVert(*charts,*ncharts,v2c);

    
    Chart * merged = new Chart[1];
    
    int ntri=0;
    for(int i=0;i<*ncharts;i++)
      ntri+=charts[0][i].npoly;
    merged->init(ntri,v2c.size());    
    vert2cholyvec::iterator first=v2c.begin();
    vert2cholyvec::iterator end=v2c.end();
    int vi=0;
    while(first!=end){
      merged->vert[vi]=(*first).first;
      v2i[(*first).first]=vi;
      first++;
      vi++;
    }
    printf("added all verts\n");
    
    ntri=0;
    for(int i=0;i<*ncharts;i++){
      for(int j=0;j<charts[0][i].npoly;j++){
	int v0=v2i[(*charts)[i].vert[(*charts)[i].poly[j][0]]];
	int v1=v2i[(*charts)[i].vert[(*charts)[i].poly[j][1]]];
	int v2=v2i[(*charts)[i].vert[(*charts)[i].poly[j][2]]];
	merged->tc[v0]=charts[0][i].tc[charts[0][i].poly[j][0]];
	merged->tc[v1]=charts[0][i].tc[charts[0][i].poly[j][1]];
	merged->tc[v2]=charts[0][i].tc[charts[0][i].poly[j][2]];
	merged->poly[ntri][0]=v0;
	merged->poly[ntri][1]=v1;
	merged->poly[ntri][2]=v2;
	ntri++;
      }
    }
    merged->initNormals();
    Chart * newCharts = new Chart[*ncharts];
    unsigned char * inchart=new unsigned char[merged->nvert];
    int * mapping=new int[merged->nvert];
    for(int i=0;i<*ncharts;i++){
      memset(mapping,0,sizeof(int)*merged->nvert);
      memset(inchart,0,merged->nvert);
      int newnvert=0;

      for(int j=0;j<charts[0][i].nvert;j++){
	cholyvec cv=v2c[charts[0][i].vert[j]];
	cholyvec::iterator finger=cv.begin();
	cholyvec::iterator end=cv.end();
	while(finger!=end){
	  int charti=(*finger).chart;
	  int polyi=(*finger).poly;
	  Chart * c=(*charts)+charti;
	  int v0=v2i[c->vert[c->poly[polyi][0]]];
	  int v1=v2i[c->vert[c->poly[polyi][1]]];
	  int v2=v2i[c->vert[c->poly[polyi][2]]];
	  newnvert+=(!inchart[v0]);
	  newnvert+=(!inchart[v1]);
	  newnvert+=(!inchart[v2]);
	  inchart[v0]=1;
	  inchart[v1]=1;
	  inchart[v2]=1;
	  finger++;
	}	
      }
      printf("newnvert is %d, old is %d\n",newnvert,charts[0][i].nvert);
      int newntri=0;
      for(int k=0;k<merged->npoly;k++){
	if(inchart[merged->poly[k][0]]&&
	   inchart[merged->poly[k][1]]&&
	   inchart[merged->poly[k][2]])newntri++;
      }
      newCharts[i].init(newntri,newnvert);
      newnvert=0;
      newntri=0;
      for(int k=0;k<merged->nvert;k++){
	if(inchart[k]){
	  newCharts[i].vert[newnvert]=merged->vert[k];
	  newCharts[i].tc[newnvert]=merged->tc[k];
	  newCharts[i].norm[newnvert]=merged->norm[k];
	  mapping[k]=newnvert;
	  newnvert++;
	}
      }
      for(int k=0;k<merged->npoly;k++){
	if(inchart[merged->poly[k][0]]&&
	   inchart[merged->poly[k][1]]&&
	   inchart[merged->poly[k][2]]){
	  newCharts[i].poly[newntri][0]=mapping[merged->poly[k][0]];
	  newCharts[i].poly[newntri][1]=mapping[merged->poly[k][1]];
	  newCharts[i].poly[newntri][2]=mapping[merged->poly[k][2]];
	  newntri++;
	}
      }
    }
    delete [] mapping;
    delete [] inchart;

    delete [] (*charts);
    delete [] merged;
    *charts=newCharts;
    printf("done, returning\n");
  }
  return 0;
}

extern "C" const void * getPanel(wxWindow * parent){
  return 0;
}
