#include <stdio.h>
#include <stdlib.h>
#include "chart.h"
#include "matrix.h"
#include "texgen.h"
#include "plugin_defines.h"

extern char currentProj[];

extern "C" const char *  getName(){
  return "Rem Stick";
}
extern "C" const int  getType(){
  return TEXPLUGIN_OTHER_TYPE;
}
extern "C" const char *  getInfo(){
  return "Remove stick geometry";
}
extern "C" int apply(Chart ** charts,int * ncharts){
  if(!(*ncharts))return 0;
  int nvert=0;
  int nremvert=(*charts)[(*ncharts)-1].nvert;
  int allowedVert=0;
  Chart * newCharts = new Chart[*ncharts-1];
  for(int i=0;i<(*ncharts)-1;i++){
    newCharts[i]=(*charts)[i];
  }
  delete [] (*charts);
  *(charts)=newCharts;
  (*ncharts)--;
  
  //remove it from the output file
  char ofile[1024];
  char bfile[1024];
  sprintf(ofile,"%s/output/data0/geometry.obj",currentProj);
  sprintf(bfile,"%s/output/data0/geometry_back.obj",currentProj);
  FILE * f=fopen(ofile,"r");
  FILE * b=fopen(bfile,"w");
  if(!f){
    printf("cannot open geometry file [%s]\n",ofile);
    return 0;
  }
  printf("Fixing up %s\n",ofile);
  char line[1024];
  while(fgets(line,1024,f)){
    if(strstr(line,"v ") || strstr(line,"V ")){
      nvert++;
    }
    fprintf(b,line);
  }
  allowedVert=nvert-nremvert;
  fclose(b);
  fclose(f);
  
  f=fopen(ofile,"w");
  b=fopen(bfile,"r");
  nvert=0;
  int ntvert=0;
  while(fgets(line,1024,b)){
    if(strstr(line,"v ") || strstr(line,"V ")){
      if(nvert<allowedVert){
	fprintf(f,line);
      }
      nvert++;
    }
    else if(strstr(line,"vt ") || strstr(line,"VT ")){
      if(ntvert<allowedVert){
	fprintf(f,line);
      }
      ntvert++;
    }
    else if(strstr(line,"f ") || strstr(line,"F ")){
      int v1,v2,v3;
      if(sscanf(line+2,"%d %d %d",&v1,&v2,&v3)==3){
	if(v1-1<allowedVert &&
	   v2-1<allowedVert &&
	   v3-1<allowedVert){
	  fprintf(f,line);
	}
      }
    }
    else{
      fprintf(f,line);
    }
  }
  fclose(b);
  fclose(f);
  return 0;
}
extern "C" const void * getPanel(void * v){
  return 0;
}
