#ifndef SOCKET_H
#define SOCKET_H

#define SOCKET_CLIENT 0
#define SOCKET_SERVER 1

#ifdef _WIN32
 #include <windows.h>
#else
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <netdb.h>
 #include <sys/poll.h>
#endif
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef _WIN32
 #include <windows.h>
#endif
class Socket
{
public:
	Socket();
	Socket(int type);

	int bind(unsigned short port);
	int listen(int backlog);

	Socket * accept();

	
int ready();

	int recv(char * bytes,int len);
	int recvln(char * bytes,int len);


	int send(char * bytes,int len);
	int send(char * bytes,int len,int flags);

	int connect(char * str, unsigned short port);

	int getSock(){return sock;};

	~Socket();
	int sock;
	void (* errorFunc)(char *);
};


#endif



