#include "newseg.h"

int ww=256;
int wh=256;
double * g_centers=0;
int * g_sizes=0;
int * g_labels=0;
int * g_labels2=0;
int g_ncenters=0;
int ** g_lines=0;
int g_nlines=0;
double g_center[2];
Matrix g_ellipse1;
Matrix g_ellipse2;
double startAngle;

//#define LOCAL_OPTIMIZE 1

#define MAX(a,b)((a)>(b)?(a):(b))
#define MIN(a,b)((a)<(b)?(a):(b))
#define SIGN(a,b)((b)>=0 ? fabs(a):-fabs(a))
#define SQR(x)((x)*(x))

void prnt(char * fmt,...)
{
#ifdef PD
  va_list ap;
  int d;
  char c, *p, *s;
  char buffer[2048];
  va_start(ap,fmt);
  vsnprintf(buffer,2047,fmt,ap);

  int len=strlen(buffer);
  printf(buffer);

  va_end(ap);
#endif
}

Matrix g_kc(5,1);
Matrix g_intrinsic=Matrix::eye(3);
Matrix g_extrinsic;


#ifdef USE_DISPLAY_HELPER
#include <GL/glut.h>
void drawString(double x,double y,char * fmt,...)
{
  va_list ap;
  int d;
  char c, *p, *s;
  char buffer[2048];
  va_start(ap,fmt);
  vsnprintf(buffer,2047,fmt,ap);

  int len=strlen(buffer);

  glRasterPos2d(x,y);
  for(int i=0;i<len;i++){
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18,buffer[i]);
  }

  va_end(ap);
}
#endif

Image8 original;
Image8 current;
int thresh=100;

/*
int threshold(image * result,image8 & original,int thresh[3])
{
  int temp[3];
  int all;
  if(result->w!=original->w ||
     result->h!=result->h){
    printf("invalid result size for threshold\n");
    return 0;
  }
  
  for(int i=0;i<result->h;i++){
    for(int j=0;j<result->w;j++){
      imageGet(original,j,i,temp);
      temp[0]=(temp[0]<=thresh[0]);
      temp[1]=(temp[1]<=thresh[1]);
      temp[2]=(temp[2]<=thresh[2]);
      all=temp[0]&&temp[1]&&temp[2];
      all*=255;
      temp[0]=temp[1]=temp[2]=all;
      imageSet(result,j,i,temp);
    }
  }
}*/


int visited;
int fill(Image8 & im,int * labels,int x,int y,int label,int depth=0)
{
  if(depth>1000)return 0;
  if(im(x,y)>0 && labels[y*im.width+x]==-1){
    int filled=1;
    labels[y*im.width+x]=label;
    if(x-1>=0){
      filled+=fill(im,labels,x-1,y,label,depth+1);
    }
    if(x+1<im.width){
      filled+=fill(im,labels,x+1,y,label,depth+1);
    }
    if(y-1>=0){
      filled+=fill(im,labels,x,y-1,label,depth+1);
    }
    if(y+1<im.height){
      filled+=fill(im,labels,x,y+1,label,depth+1);
    }    
    return filled;
  }  
  return 0;
}

int bottomup(Image8 & im,double ** cntrs,int ** szs,
	      int minsize,int maxsize,int & threshold);

/**
 * Find the centers of regions in the black and white image.
 * The centers are located in the black and white image and only
 * those satisfying minsize <= regionsize < maxsize are accepted 
 * \param im the input black and white image to find centers in
 * \param cntrs the centers of the detected regions
 * \param szs the sizes of the detected regions
 * \param minsize the minimum size of region to accept
 * \param maxsize the maximum size of region to accept
 * \return the number of centers detected
 * \sa bottomup
 */
int findCenters(Image8 & im,
		double ** cntrs,int ** szs,
		int minsize=10,int maxsize=1000)
{
 visited=0;
  int ncenters=0;
  int * labels= new int[im.width*im.height];
  int nlabels=0;
  int max=32;
  int * sizes;
  sizes = new int[max];
  
  memset(labels,0xff,sizeof(int)*im.height*im.width);
  
  for(int x=0;x<im.width;x++){
    for(int y=0;y<im.height;y++){
      int size;
      if(size=fill(im,labels,x,y,nlabels)){
	if(nlabels>=max){
	  max*=2;
	  int * ng = new int[max];
	  memcpy(ng,sizes,sizeof(int)*nlabels);
	  delete [] sizes;
	  sizes=ng;
	}
	sizes[nlabels]=size;
	nlabels++;
      } 
    }
  }

  if(!nlabels){
    delete [] sizes;
    delete [] labels;
    return 0;
  }

  double * centers[2];
  centers[0]=new double[nlabels];
  centers[1]=new double[nlabels];
  
  memset(centers[0],0,sizeof(double)*nlabels);
  memset(centers[1],0,sizeof(double)*nlabels);
  

  for(int x=0;x<im.width;x++){
    for(int y=0;y<im.height;y++){
      int lab = labels[y*im.width+x];
      if(lab>=0 && sizes[lab]>=minsize && sizes[lab]<=maxsize){
	centers[0][lab]+=x;
	centers[1][lab]+=y;
      }
    }
  }

  int ngood=0;
  for(int i=0;i<nlabels;i++){
    if(sizes[i]>=minsize && sizes[i]<=maxsize){
      centers[0][i]/=((double)sizes[i]);
      centers[1][i]/=((double)sizes[i]);
      //glBegin(GL_POINTS);
      //glColor3f(1.0,0.0,1.0);
      //glVertex2d(centers[0][i],centers[1][i]);
      //glEnd();
      ngood++;
    }
  }
  if(ngood){
    *cntrs = new double[2*ngood];
    *szs = new int[ngood];
    
    int gi=0;
    for(int i=0;i<nlabels;i++){
      if(sizes[i]>=minsize && sizes[i]<=maxsize){
	(*cntrs)[gi]=centers[0][i];
	(*cntrs)[gi+ngood]=centers[1][i];
	(*szs)[gi]=sizes[i];
	gi++;
      }
    }
#ifdef PD
    prnt("%d %d\n",gi,ngood);
#endif
  }
  delete [] centers[0];
  delete [] centers[1];
  delete [] labels;
  delete [] sizes;
#ifdef PD
  prnt("nlabels %d/%d\n",ngood,nlabels);
#endif
  return ngood;
}



/*
class Vec2f{
public:
  double x;
  double y;
public:
  Vec2f(Vec2f & other){
    x=other.x;
    y=other.y;
  }
  Vec2f(double _x,double _y){
    x=_x;
    y=_y;
  }
  void sub(Vec2f & other){
    x-=other.x;
    y-=other.y;
  }
  void add(Vec2f & other){
    x+=other.x;
    y+=other.y;
  }
  double len()
  {
    return sqrt(x*x+y*y);
  }
  double dot(Vec2f & o)
  {
    return x*o.x+y*o.y;
  }
  void mult(double d)
  {
    x*=d;
    y*=d;
  }
  double normalize(){
    double l =len();
    x/=l;
    y/=l;
    return l;
  }
};
*/


/** 
 * Finds the lines using the given centers.
 */
int findLines(double * centers,int * sizes,int ncenters,int *** lines)
{
  int * others = new int[ncenters];
  double * idist=new double[ncenters];
  double * jdist=new double[ncenters];
  int maxlines=32;
  int nlines=0;
  double * lineLengths = new double[maxlines];
  (*lines)=new int * [maxlines];

  for(int i=0;i<ncenters;i++){
    Vec2f ivec(centers[i],centers[ncenters+i]);
    for(int j=0;j<ncenters;j++){
      if(j==i)continue;
      Vec2f jvec(centers[j],centers[ncenters+j]);
      Vec2f diff(jvec);
      int onLine=0;
      diff-=ivec;
      double difflen=diff.normalize();

      for(int k=0;k<ncenters;k++){
	if(k!=i && k!=j){
	  Vec2f kvec(centers[k],centers[ncenters+k]);
	  Vec2f kminusi(kvec);
	  kminusi-=ivec;
	  double kminusilen=kminusi.normalize();
	  double d = diff.dot(kminusi);

	  if(d>=0 && d*kminusilen>difflen)
	  {
	    Vec2f projOnLine(diff);
	    projOnLine*=(kminusilen*d);
	    projOnLine+=ivec;

	    Vec2f distFromLine(kvec);
	    distFromLine-=projOnLine;
	    if(distFromLine.len()<5){//was 5
		idist[onLine]=d*kminusilen;
		jdist[onLine]=idist[onLine]-difflen;
		others[onLine++]=k;
	    }
	  }
	}
      }
      if(onLine>=2){
	  //sort in order of closest to point i
	  for(int h=0;h<onLine-1;h++){
	      int smallesth=h;
	      for(int hh=h+1;hh<onLine;hh++){
		  if(idist[hh]<idist[smallesth]){
		      smallesth=hh;
		  }
	      }
	      double idistback=idist[h];
	      double jdistback=jdist[h];
	      int onLineback=others[h];
	      idist[h]=idist[smallesth];
	      jdist[h]=jdist[smallesth];
	      others[h]=others[smallesth];
	      idist[smallesth]=idistback;
	      jdist[smallesth]=jdistback;
	      others[smallesth]=onLineback;
	  }

	  double cross;
	  cross=(idist[1]/idist[0])/(jdist[1]/jdist[0]);

	  if(fabs(cross-0.75)<0.03){//was 0.03
	      if(nlines>=maxlines){
		  maxlines*=2;
		  int ** newlines=new int * [maxlines];
		  memcpy(newlines,*lines,sizeof(int*)*nlines);
		  delete [] (*lines);
		  (*lines)=newlines;

		  double * newLengths = new double[maxlines];
		  memcpy(newLengths,lineLengths,sizeof(double)*nlines);
		  delete [] lineLengths;
		  lineLengths=newLengths;
	      }
	      (*lines)[nlines]=new int[4];
	      lineLengths[nlines]=idist[1];

	      if(i<others[1]){
		  (*lines)[nlines][0]=i;
		  (*lines)[nlines][1]=j;
		  (*lines)[nlines][2]=others[0];
		  (*lines)[nlines][3]=others[1];
	      }
	      else{
		  (*lines)[nlines][0]=others[1];
		  (*lines)[nlines][1]=others[0];
		  (*lines)[nlines][2]=j;
		  (*lines)[nlines][3]=i;
	      }
#ifdef PD
	      prnt("%d %d %d %d\n",(*lines)[nlines][0],
		     (*lines)[nlines][1],
		     (*lines)[nlines][2],
		     (*lines)[nlines][3]);
#endif
	      nlines++;
	      /*
	      glBegin(GL_LINES);
	      glVertex2f(ivec.x,ivec.y);
	      glVertex2f(jvec.x,jvec.y);
	      glEnd();*/
	  }
      }
    }
  }
  double avgLen=0;
  double bigLen=0;
  for(int i=0;i<nlines;i++){
    avgLen+=lineLengths[i];
    if(lineLengths[i]>bigLen)
      bigLen=lineLengths[i];
    for(int j=i+1;j<nlines;j++){
      if((*lines)[i][0]==(*lines)[j][0] &&
	 (*lines)[i][1]==(*lines)[j][1] &&
	 (*lines)[i][2]==(*lines)[j][2] &&
	 (*lines)[i][3]==(*lines)[j][3]){
	delete [] (*lines)[j];
	nlines--;
	for(int k=j;k<nlines;k++){
	  (*lines)[k]=(*lines)[k+1];
	  lineLengths[k]=lineLengths[k+1];
	}
	//j--;
      }
    }
  }
  if(nlines){
    avgLen/=nlines;
  }
  int bigLine = (original.width+original.height)/8;
  for(int i=0;i<nlines;i++){
    if(lineLengths[i]>bigLine){
      delete [] (*lines)[i];

      nlines--;
      for(int j=i;j<nlines;j++){
	(*lines)[j]=(*lines)[j+1];
	lineLengths[j]=lineLengths[j+1];
      }
      i--;

    }
  }
#ifdef PD
  prnt("nlines %d, avgLen=%f, bigLen=%f\n",nlines,avgLen,bigLen);
#endif
  

  delete [] idist;
  delete [] jdist;
  delete [] others;
  return nlines;
}

/** 
 * Finds the center of the calibration pattern using the
 * given lines, while ignoring the index given in "ignore".
 * This is a helper function used by findCenterOfPattern().
 */
Matrix findCenterOfPattern(double * centers,int * sizes,int ncenters,
			     int ** lines,int * nlines,double * res,int ignore)
{
  int nl=(*nlines)-(ignore>=0);
  
  Matrix A(nl,2);
  Matrix B(nl,1);
  int li=0;
  for(int i=0;i<*nlines;i++){
    if(i!=ignore){
      Vec3d a(centers[lines[i][0]],
	     centers[lines[i][0]+ncenters],1);
      Vec3d b(centers[lines[i][3]],
	     centers[lines[i][3]+ncenters],1);
      Vec3d c;
      c=a.cross(b);
      A(li,0)=c.x;
      A(li,1)=c.y;
      B(li,0)=-c.z;
      li++;
    }
  }
  /*Matrix At=A.transpose();
  Matrix ata = At.mult(A);
  Matrix atainv=ata.inverse();
  Matrix atb= At.mult(B);
  Matrix x = atainv.mult(atb);
  Matrix temp = A.mult(x);
  */
  Matrix At=A.transpose();
  Matrix x=((At*A).inverse())*(At*B);
  Matrix temp = A*x;

  temp-=(B);
  Matrix residual = temp.transpose()*(temp);
  if(nl)
    residual*=(1.0/(nl*nl));
  double r = residual(0,0);

  *res=r;
  return x;
}

/** 
 * Finds the center of the calibration pattern using the
 * given lines.
 * A least squares fit is done to find the center of the pattern.
 * If the residual is high, then lines are considered for removal.
 */
Matrix  findCenterOfPattern(double * centers,int * sizes,int ncenters,
			     int ** lines,int * nlines)
{
  double res;
  Matrix x;

  x=findCenterOfPattern(centers,sizes,ncenters,lines,nlines,&res,-1);
  if(res<1000){
    return x;
  }
  else{
    while(1){
      double smallestRes=10e15;
      int smallestResi=0;
      for(int i=0;i<*nlines;i++){
	Matrix x2;
	double tres;
	x2=findCenterOfPattern(centers,sizes,ncenters,
			       lines,nlines,&tres,i);
#ifdef PD
	prnt("%d: %f\n",i,tres);
#endif
	if(tres<smallestRes){
	  smallestRes=tres;
	  smallestResi=i;
	  //delete x;
	  x=x2;
	}
      }
#ifdef PD
      prnt("should remove %d/%d\n",smallestResi,*nlines);
#endif
      delete [] lines[smallestResi];
      (*nlines)--;
      for(int i=smallestResi;i<*nlines;i++){
	lines[i]=lines[i+1];
      }
      if(smallestRes<1000){
	return x;
      }
    }
  }
}

///Center voting grid size used in removeBadLines()
#define GSIZE 32
///Center voting grid size-1 used in removeBadLines()
#define GSIZE_1 31.0
/** 
 * Finds and removes any detected bad lines.
 * This function uses a similar method as pointed out by
 * the canon people for detecting the center of the pattern.
 * The image is discritized at low res. and the this low res
 * image is used to keep track of how many intersections occur
 * within a gridsquare.  The gridsquare with the most votes
 * is taken to be the center.  Any lines that do not have an
 * intersection (with any other line) that lies within this
 * center pixel, are considered bad.  These are typically the
 * lines that are use the dots from multiple "lines" (ie. almost perpendicular)
 */
void removeBadLines(double * centers,int * sizes,int ncenters,
		    int ** lines,int * nlines)
{
  int votes[GSIZE][GSIZE];
  int * badline;
  double minx=10e10,miny=10e10;
  double maxx=-10e10,maxy=-10e10;
  for(int i=0;i<ncenters;i++){
    minx=MIN(minx,centers[i]);
    maxx=MAX(maxx,centers[i]);
    miny=MIN(miny,centers[i+ncenters]);
    maxy=MAX(maxy,centers[i+ncenters]);
  }
  int maxbadline=0;
  badline = new int[*nlines];
  memset(badline,0,sizeof(int)*(*nlines));
  memset(votes,0,sizeof(int)*GSIZE*GSIZE);
  for(int i=0;i<*nlines;i++){
    Vec3d l1=Vec3d(centers[(lines)[i][0]],
		   centers[ncenters+(lines)[i][0]],1).cross
      (Vec3d(centers[(lines)[i][3]],
	     centers[ncenters+(lines)[i][3]],1));
    
    for(int j=i+1;j<*nlines;j++){
      Vec3d l2=Vec3d(centers[(lines)[j][0]],
		   centers[ncenters+(lines)[j][0]],1).cross
      (Vec3d(centers[(lines)[j][3]],
	     centers[ncenters+(lines)[j][3]],1));
      Vec3d isect=l1.cross(l2);
      isect*=(1.0/isect.z);
      //hmmm, intersection is out of bounds...prbly a bad line involved
      if(isect.x<minx || isect.x>maxx ||
	 isect.y<miny || isect.y>maxy){
	badline[i]++;
	badline[j]++;
	if(badline[i]>maxbadline)maxbadline=badline[i];
	if(badline[j]>maxbadline)maxbadline=badline[j];
      }
      else{
	int xind=(int)(GSIZE_1*(isect.x-minx)/(maxx-minx));
	int yind=(int)(GSIZE_1*(isect.y-miny)/(maxy-miny));
	if(xind>=0 && yind>=0 && xind<GSIZE_1 && yind<GSIZE_1)
	  votes[xind][yind]++;
	//votes[xind][yind]+=(!badline[i]&&!badline[j]);//add an extra vote if they aren't bad
	printf("%d %d\n",xind,yind);
      }
    }
  }
  int bestx=0;
  int besty=0;
  int secondbest=0;
  for(int y=0;y<GSIZE;y++){
    for(int x=0;x<GSIZE;x++){
      if(votes[x][y]>votes[bestx][besty]){
	bestx=x;
	besty=y;
      }
      else if(votes[x][y]>secondbest)
	secondbest=votes[x][y];
    }
  }
  printf("maxbadline is %d\n",maxbadline);
  printf("center is at %d %d (%d/%d)\n",bestx,besty,votes[bestx][besty],
	 secondbest);
  printf("which means %f %f\n",(maxx-minx)*((float)bestx)/GSIZE_1+minx,
	 (maxy-miny)*((float)besty)/GSIZE_1+miny);

  for(int i=0;i<*nlines;i++){
    Vec3d l1=Vec3d(centers[(lines)[i][0]],
		   centers[ncenters+(lines)[i][0]],1).cross
      (Vec3d(centers[(lines)[i][3]],
	     centers[ncenters+(lines)[i][3]],1));
    int okay=0;
    for(int j=0;j<*nlines;j++){
      if(i==j)continue;
      Vec3d l2=Vec3d(centers[(lines)[j][0]],
		   centers[ncenters+(lines)[j][0]],1).cross
      (Vec3d(centers[(lines)[j][3]],
	     centers[ncenters+(lines)[j][3]],1));
      Vec3d isect=l1.cross(l2);
      isect*=(1.0/isect.z);
      //hmmm, intersection is out of bounds...prbly a bad line involved
      if(isect.x<minx || isect.x>maxx ||
	 isect.y<miny || isect.y>maxy){
      }
      else{
	int xind=(int)(GSIZE_1*(isect.x-minx)/(maxx-minx));
	int yind=(int)(GSIZE_1*(isect.y-miny)/(maxy-miny));
	if(fabs(xind-bestx)+fabs(yind-besty)==0){
	  okay=1;
	  break;
	}
      }
    }
    if(!okay){
      delete [] lines[i];
      (*nlines)--;
      for(int k=i;k<*nlines;k++){
	lines[k]=lines[k+1];
      }
      i--;
      
      printf("badline %d\n",i);
    }
  }

  delete [] badline;
}

double best=0;
int order[32];
int bestorder[32];

/**
 * Search for a path through the probability matrix prob.
 */
double search(Matrix & prob,int i=0,int j=0,int wrap=0,double soFar=0.0)
{
  double res=0;
  int jinitial=j;
  if(i>=g_nlines || i>=32){
    return soFar;
  }
  //prnt("calling search %d,%d,%d\n",i,j,wrap);
  for(;j<15 &&(!wrap||(wrap && j<order[0]));j++){
    if(prob(i,j)>0.00001){
      order[i]=j;
      //prnt("%d %d\n",i,j);
      if((res=search(prob,i+1,j+1,wrap,soFar+prob(i,j)))>best){
	best=res;
	prnt("best:%f\n",best);
	memcpy(bestorder,order,sizeof(int)*32);
      }
    }
  }
  if(!wrap){
    wrap=1;
    j=0;
    for(j=0;j<jinitial&&(!wrap||(wrap && j<order[0]));j++){
      if(prob(i,j)>0.00001){
	order[i]=j;
	//prnt("%d %d\n",i,j);
	if((res=search(prob,i+1,j+1,wrap,soFar+prob(i,j)))>best){
	  best=res;
	  prnt("best:%f\n",best);
	  memcpy(bestorder,order,sizeof(int)*32);
	}
      }
    }
  }
  return 0;
}

/**
 * A probabalistic attempt at labeling the lines.
 * Given the probability that the sizes of the regions may
 * be detected wrong, this function attempts to find the most
 * likely labeling of the detected lines.  The pdf's of the neighboring 
 * lines are used to update the pdf of the current line.  This function
 * has not been thoroughly tested.
 * \return the labels associated with each line
 */
int * labelLines2()
{
  Matrix porig(g_nlines,15);

  for(int i=0;i<g_nlines;i++){
    int smallest=MIN(g_sizes[g_lines[i][0]],
		 g_sizes[g_lines[i][1]]);
    smallest=MIN(smallest,
		 g_sizes[g_lines[i][2]]);
    smallest=MIN(smallest,
		 g_sizes[g_lines[i][3]]);
    int biggest=MAX(g_sizes[g_lines[i][0]],
		 g_sizes[g_lines[i][1]]);
    biggest=MAX(biggest,
		 g_sizes[g_lines[i][2]]);
    biggest=MAX(biggest,
		 g_sizes[g_lines[i][3]]);
    
    double psmall[4];
    double range=(biggest)-(smallest);
    /*
    double middle=pow(0.5*(sqrt(smallest)+sqrt(biggest)),2);
    double sig=4*(biggest-smallest);
    double sig2=sig*sig;
    
    psmall[0]=exp(-SQR(g_sizes[g_lines[i][0]]-smallest)/(2*sig2));
    psmall[1]=exp(-SQR(g_sizes[g_lines[i][1]]-smallest)/(2*sig2));
    psmall[2]=exp(-SQR(g_sizes[g_lines[i][2]]-smallest)/(2*sig2));
    psmall[3]=exp(-SQR(g_sizes[g_lines[i][3]]-smallest)/(2*sig2));
   
    double normalize=1.0/(sig*sqrt(2*M_PI));
    psmall[0]*=normalize;
    psmall[1]*=normalize;
    psmall[2]*=normalize;
    psmall[3]*=normalize;
    */

    psmall[0]=((biggest)-(g_sizes[g_lines[i][0]]))/range;
    psmall[1]=((biggest)-(g_sizes[g_lines[i][1]]))/range;
    psmall[2]=((biggest)-(g_sizes[g_lines[i][2]]))/range;
    psmall[3]=((biggest)-(g_sizes[g_lines[i][3]]))/range;
    
    prnt("%d %f %f %f %f\n",i,
	   psmall[0],
	   psmall[1],
	   psmall[2],
	   psmall[3]);

    int js[]={0,0,0,0};
    
    for(int j0=0;j0<=1;j0++){
      for(int j1=0;j1<=1;j1++){
	for(int j2=0;j2<=1;j2++){
	  for(int j3=0;j3<=1;j3++){
	    int which=j0*8+j1*4+j2*2+j3*1;
	    double prob=1.0;
	    if(j0)
	      prob*=(1.0-psmall[0]);
	    else
	      prob*=(psmall[0]);
	    if(j1)
	      prob*=(1.0-psmall[1]);
	    else
	      prob*=(psmall[1]);
	    if(j2)
	      prob*=(1.0-psmall[2]);
	    else
	      prob*=(psmall[2]);
	    if(j3)
	      prob*=(1.0-psmall[3]);
	    else
	      prob*=(psmall[3]);
	    if(which==0)continue;
	    which--;
	    porig(i,which)=prob;
	  }
	}
      } 
    }
  }
  //normalize rows of porig
  for(int i=0;i<porig.m;i++){
    double sum=0;
    for(int j=0;j<15;j++){
      sum+=porig(i,j);
    }
    for(int j=0;j<15;j++){
      porig(i,j)/=sum;
    }
  }

  
  Matrix thetas(g_nlines,1);
  //Compute the angles of each line
  for(int i=0;i<g_nlines;i++){
    double dx=g_centers[g_lines[i][0]]-g_ellipse1[0];
    double dy=g_centers[g_lines[i][0]+g_ncenters]-g_ellipse1[1];
    double theta=atan2(dy,dx)-g_ellipse1[4];
    if(theta<0)
      theta+=2*M_PI;
    thetas[i]=theta;
  }
  int * forward = new int[g_nlines];
  int * labels = new int[g_nlines];

  for(int i=0;i<g_nlines;i++)forward[i]=i;

  for(int i=0;i<g_nlines;i++){
    int smallest=i;
    for(int j=i+1;j<g_nlines;j++){
      if(thetas[j]<thetas[smallest]){
	smallest=j;
      }
    }  
    for(int j=0;j<15;j++){
      double temp=porig(i,j);
      porig(i,j)=porig(smallest,j);
      porig(smallest,j)=temp;
    }
    int temp=forward[i];
    forward[i]=forward[smallest];
    forward[smallest]=temp;
    double tangle = thetas[i];
    thetas[i]=thetas[smallest];
    thetas[smallest]=tangle;
  }

  prnt("forward:");
  for(int i=0;i<g_nlines;i++){
    prnt("%d ",forward[i]);
  }
  prnt("\n");

  prnt("Searching\n");
  best=0;
  order[0]=10000;
  search(porig);
  //porig.print();
  prnt("Search done\n");

  for(int i=0;i<g_nlines;i++){
    labels[forward[i]]=bestorder[i]+1;
  }
  prnt("BEST:");
  for(int i=0;i<g_nlines;i++){
    prnt("%d ",bestorder[i]+1);
  }
  prnt("Labels:");
  for(int i=0;i<g_nlines;i++){
    prnt("%d ",labels[i]);
  }
  prnt("\n");
  return labels;
}

int *  orderLines(double * centers,int * sizes,int ncenters,
		  int ** lines,int nlines,Matrix & center)
{
  int * labels=0;
  double * angles=0;
  if(nlines){
    Vec2f cent(center.get(0,0),center.get(1,0));
    labels = new int[nlines];
    angles = new double[nlines];

    for(int i=0;i<nlines;i++){
      Vec2f end1(centers[lines[i][0]],
		centers[lines[i][0]+ncenters]);
      Vec2f end2(centers[lines[i][3]],
		centers[lines[i][3]+ncenters]);
      end1-=cent;
      end2-=cent;
      if(end2.len()<end1.len()){
	int temp = lines[i][0];
	lines[i][0]=lines[i][3];
	lines[i][3]=temp;
	temp = lines[i][1];
	lines[i][1]=lines[i][2];
	lines[i][2]=temp;
      }

      int biggest=sizes[lines[i][0]];
      if(sizes[lines[i][1]]>biggest)
	  biggest=sizes[lines[i][1]];
      if(sizes[lines[i][2]]>biggest)
	  biggest=sizes[lines[i][2]];
      if(sizes[lines[i][3]]>biggest)
	  biggest=sizes[lines[i][3]];

      int smallest=sizes[lines[i][0]];
      if(sizes[lines[i][1]]<smallest)
	  smallest=sizes[lines[i][1]];
      if(sizes[lines[i][2]]<smallest)
	  smallest=sizes[lines[i][2]];
      if(sizes[lines[i][3]]<smallest)
	  smallest=sizes[lines[i][3]];

      double middle=pow(0.5*(sqrt(smallest)+sqrt(biggest)),2);//(int)(0.65*biggest);
     
      angles[i]=atan2(end1.y,end1.x);
      labels[i]=(sizes[lines[i][0]]>=middle)*8+
	(sizes[lines[i][1]]>=middle)*4+
	(sizes[lines[i][2]]>=middle)*2+
	(sizes[lines[i][3]]>=middle)*1;
    }
    delete [] angles;
  }
  return labels;
}

void groupToPoint(double * centers,int * sizes,int ncenters,
		  int ** lines,int nlines,int * labels,int * ignore,
		  Matrix &worldp,Matrix &imagep)
{
  int psofar=0;
  double sr = 10;
  double radii[] = {300,300,300,300};
  int which=0;
  int ngoodlines=0;
  radii[0]-=sr*12;
  radii[1]-=sr*8;
  radii[2]-=sr*4;
  radii[3]-=sr*0;

  for(int i=0;i<nlines;i++){
    ngoodlines+=!ignore[i];
  }
  printf("ngoodlines %d, nlines %d\n",ngoodlines,nlines);

  worldp = Matrix(ngoodlines*4,3);
  imagep = Matrix(ngoodlines*4,2);

  for(which=0;which<nlines;which++){
    if(ignore[which])continue;
    //double angle = (labels[which] % 15)*2.0*M_PI/15.0;//For old pattern
    double angle = (labels[which] % 14)*2.0*M_PI/14.0;
    for(int j=0;j<4;j++){
      double y = radii[j]*sin(angle);
      double x = radii[j]*cos(angle);
      
      worldp(psofar,0)=((double)x/300.0);
      worldp(psofar,1)=0;//-150;
      worldp(psofar,2)=((double)y/300.0);
      imagep(psofar,0)=centers[lines[which][j]];
      imagep(psofar,1)=centers[lines[which][j]+ncenters];
      psofar++;
    }
    
  }
  /*prnt("world points:\n");
  worldp.print();
  prnt("image points:\n");
  imagep.print();*/
}

Matrix getHomography(Matrix & pts1,Matrix & pts2)
{
  int i=0;
  Matrix p1(pts1.m,3);
  Matrix p2(pts1.m,3);
  Matrix A(pts1.m*2,9);

  Vec2f p1m(0,0),p2m(0,0);
  double p1scale=0,p2scale=0;
  p1.setAll(1);
  p2.setAll(1);
  for(i=0;i<p1.m;i++){
    Vec2f p1pt(pts1(i,0),pts1(i,1));
    Vec2f p2pt(pts2(i,0),pts2(i,1));
    p1m+=p1pt;
    p2m+=p2pt;
    
    p1.set(i,0,p1pt.x);
    p1.set(i,1,p1pt.y);
    
    p2.set(i,0,p2pt.x);
    p2.set(i,1,p2pt.y);
  
  }
  p1m.mult(1.0/((double)p1.m));
  p2m.mult(1.0/((double)p1.m));
  for(i=0;i<p1.m;i++){
    Vec2f p1pt(pts1.get(i,0),pts1.get(i,1));
    Vec2f p2pt(pts2.get(i,0),pts2.get(i,1));
    p1pt-=p1m;
    p2pt-=p2m;
    
    p1scale+=p1pt.len();
    p2scale+=p2pt.len();

    p1(i,0)=p1pt.x;
    p1(i,1)=p1pt.y;
    
    p2(i,0)=p2pt.x;
    p2(i,1)=p2pt.y;
  }
  p1scale=sqrt(2)*((double)p1.m)/p1scale;
  p2scale=sqrt(2)*((double)p2.m)/p2scale;
  for(i=0;i<p1.m;i++){
    Vec2f p1pt(p1(i,0),p1(i,1));
    Vec2f p2pt(p2(i,0),p2(i,1));

    p1pt.mult(p1scale);
    p2pt.mult(p2scale);

    p1(i,0)=p1pt.x;
    p1(i,1)=p1pt.y;
    
    p2(i,0)=p2pt.x;
    p2(i,1)=p2pt.y;
  }
  
  //Set up the linear approximation in A
  for(i=0;i<p1.m;i++){
    int i1=2*i;
    int i2=2*i+1;
    double x,y,w;

    x=p1(i,0);//;imagep->get(i,0);
    y=p1(i,1);//limagep->get(i,1);
    w=1;
      
    A(i1,0)=0;
    A(i1,1)=0;
    A(i1,2)=0;
    A(i1,3)=-w*p2(i,0);
    A(i1,4)=-w*p2(i,1);
    A(i1,5)=-w*1;
    A(i1,6)=y*p2(i,0);
    A(i1,7)=y*p2(i,1);
    A(i1,8)=y*1;
    
    A(i2,0)=w*p2(i,0);
    A(i2,1)=w*p2(i,1);
    A(i2,2)=w*1;
    A(i2,3)=0;
    A(i2,4)=0;
    A(i2,5)=0;
    A(i2,6)=-x*p2(i,0);
    A(i2,7)=-x*p2(i,1);
    A(i2,8)=-x*1;
  }

  Matrix s,v,d;
  A.svd(s,v,d);
  
  Matrix p = d.getColumn(8);
  p.m=3;
  p.n=3;
    
  Matrix ip1tformi=Matrix::eye(3);
  Matrix ip2tform=Matrix::eye(3);
  
  ip1tformi(0,0)=1.0/p1scale;
  ip1tformi(1,1)=1.0/p1scale;
  ip1tformi(2,2)=1.0;
  ip1tformi(0,2)=p1m.x;
  ip1tformi(1,2)=p1m.y;
  
  ip2tform(0,0)=p2scale;
  ip2tform(1,1)=p2scale;
  ip2tform(2,2)=1.0;
  ip2tform(0,2)=-p2scale*p2m.x;
  ip2tform(1,2)=-p2scale*p2m.y;
  
  Matrix temp = p*ip2tform;
  Matrix temp2 = ip1tformi*temp;
  p=temp2;
  return p;
}

Matrix getHomography2(Matrix & pts1,Matrix & pts2)
{
  int i=0;
  Matrix p1(pts1.m,3);
  Matrix p2(pts1.m,3);
  Matrix A(pts1.m*2,9);

  Vec2f p1m(0,0),p2m(0,0);
  double p1sx=0,p1sy=0,p2sx=0,p2sy=0;
  p1.setAll(1);
  p2.setAll(1);
  for(i=0;i<p1.m;i++){
    Vec2f p1pt(pts1(i,0),pts1(i,1));
    Vec2f p2pt(pts2(i,0),pts2(i,1));
    p1m+=p1pt;
    p2m+=p2pt;
    
    p1.set(i,0,p1pt.x);
    p1.set(i,1,p1pt.y);
    
    p2.set(i,0,p2pt.x);
    p2.set(i,1,p2pt.y);
  
  }
  p1m.mult(1.0/((double)p1.m));
  p2m.mult(1.0/((double)p1.m));

  p2m.mult(0);

  for(i=0;i<p1.m;i++){
    Vec2f p1pt(pts1.get(i,0),pts1.get(i,1));
    Vec2f p2pt(pts2.get(i,0),pts2.get(i,1));
    p1pt-=(p1m);
    p2pt-=(p2m);
    
    p1sx+=fabs(p1pt.x);
    p1sy+=fabs(p1pt.y);
    p2sx+=fabs(p2pt.x);
    p2sy+=fabs(p2pt.y);

    p1(i,0)=p1pt.x;
    p1(i,1)=p1pt.y;
    
    p2(i,0)=p2pt.x;
    p2(i,1)=p2pt.y;
  }
  p1sx=((double)p1.m)/p1sx;
  p1sy=((double)p1.m)/p1sy;

  p2sx=((double)p1.m)/p2sx;
  p2sy=((double)p2.m)/p2sy;

  p2sx=1;
  p2sy=1;

  for(i=0;i<p1.m;i++){
    Vec2f p1pt(p1(i,0),p1(i,1));
    Vec2f p2pt(p2(i,0),p2(i,1));

    p1pt.x*=p1sx;
    p1pt.y*=p1sy;

    p2pt.x*=p2sx;
    p2pt.y*=p2sy;

    p1(i,0)=p1pt.x;
    p1(i,1)=p1pt.y;
    
    p2(i,0)=p2pt.x;
    p2(i,1)=p2pt.y;
  }

  A.setAll(0);

  //Set up the linear approximation in A
  for(i=0;i<p1.m;i++){
    if(i%2==0){
      A(i,0)=p2(i/2,0);
      A(i,1)=p2(i/2,1);
      A(i,2)=p2(i/2,2);
      A(i,6)=-p1(i/2,0)*p2(i/2,0);
      A(i,7)=-p1(i/2,0)*p2(i/2,1);
      A(i,8)=-p1(i/2,0)*p2(i/2,2);
    }
    else{
      A(i,3)=p2(i/2,0);
      A(i,4)=p2(i/2,1);
      A(i,5)=p2(i/2,2);
      A(i,6)=-p1(i/2,1)*p2(i/2,0);
      A(i,7)=-p1(i/2,1)*p2(i/2,1);
      A(i,8)=-p1(i/2,1)*p2(i/2,2);
    }
  }
  if(p1.m>4)
    A=A.transpose()*A;

  Matrix s,v,d;
  A.svd(s,v,d);
  
  Matrix p = d.getColumn(8);
  p.m=3;
  p.n=3;
  
  p*=1.0/p[8];
  
  Matrix ip1tformi=Matrix::eye(3);
  Matrix ip2tform=Matrix::eye(3);
  
  ip1tformi(0,0)=1.0/p1sx;
  ip1tformi(1,1)=1.0/p1sy;
  ip1tformi(2,2)=1.0;
  ip1tformi(0,2)=p1m.x;
  ip1tformi(1,2)=p1m.y;
  
  ip2tform(0,0)=p2sx;
  ip2tform(1,1)=p2sy;
  ip2tform(2,2)=1.0;
  ip2tform(0,2)=-p2sx*p2m.x;
  ip2tform(1,2)=-p2sy*p2m.y;
  
  Matrix temp = p*ip2tform;
  Matrix temp2 = ip1tformi*temp;
  p=temp2;
  return p;
}

/*
Excerpt from camera calibration toolbox in matlab comment:

"Let P be a point in 3D of coordinates X in the world reference frame (stored in the matrix X)
The coordinate vector of P in the camera reference frame is: Xc = R*X + T
where R is the rotation matrix corresponding to the rotation vector om: R = rodrigues(om);
call x, y and z the 3 coordinates of Xc: x = Xc(1); y = Xc(2); z = Xc(3);
The pinehole projection coordinates of P is [a;b] where a=x/z and b=y/z.
call r^2 = a^2 + b^2.
The distorted point coordinates are: xd = [xx;yy] where:

xx = a * (1 + kc(1)*r^2 + kc(2)*r^4 + kc(5)*r^6)      +      2*kc(3)*a*b + kc(4)*(r^2 + 2*a^2);
yy = b * (1 + kc(1)*r^2 + kc(2)*r^4 + kc(5)*r^6)      +      kc(3)*(r^2 + 2*b^2) + 2*kc(4)*a*b;"
*/
Matrix  projectPoints(Matrix & kc,Matrix &intrinsic,
		      Matrix &rot,Matrix &trans,Matrix &points)
{
  int j=0;
  
  Matrix pointsRot = rot*points;
  for(j=0;j<pointsRot.n;j++){
    pointsRot(0,j)+=trans(0,0);
    pointsRot(1,j)+=trans(1,0);
    pointsRot(2,j)+=trans(2,0);
  }
  for(j=0;j<pointsRot.n;j++){
    double z=pointsRot(2,j);
    double a,b,r2,r4,r6;
    double xx,yy;
    a=pointsRot(0,j)/z;
    b=pointsRot(1,j)/z;
    
    r2=a*a+b*b;
    r4=r2*r2;
    r6=r4*r2;
    xx=a*(1 + kc[0]*r2 + kc[1]*r4+kc[4]*r6)+2*kc[2]*a*b + kc[3]*(r2+2*a*a);
    yy=b*(1 + kc[0]*r2 + kc[1]*r4+kc[4]*r6)+  kc[2]*(r2 + 2*b*b)+2*kc[3]*a*b;

    pointsRot(0,j)=xx;
    pointsRot(1,j)=yy;
    pointsRot(2,j)=1;
  }

 
  

  Matrix projPoints = intrinsic*pointsRot;
  /*for(j=0;j<pointsRot.n;j++){
    double z=projPoints(2,j);
    projPoints(0,j)/=z;
    projPoints(1,j)/=z;
    projPoints(2,j)=1;
    }*/
  //projPoints->print();
  return projPoints;
}


Matrix projectPoints(Matrix & kc,Matrix &intrinsic,Matrix &params,
		     Matrix &worldp)
{
  Matrix trans(3,1);
  Matrix threeby1(3,1);
  Matrix rot;
  threeby1(0,0)=params(0,0);
  threeby1(1,0)=params(1,0);
  threeby1(2,0)=params(2,0);
  
  rot=threeby1.rod2matrix();
  
  trans(0,0)=params(3,0);
  trans(1,0)=params(4,0);
  trans(2,0)=params(5,0);
  
  Matrix pts=projectPoints(kc,intrinsic,rot,trans,worldp);
  //pts.printMatlab("proj_points");
  return pts;
}

Matrix non_lin_worldp;
Matrix non_lin_kc;
Matrix non_lin_intrinsic;
Matrix non_lin_imagep;

void non_lin_opt(const int & m,
		 const int & n,
		 double * x,
		 double * fvec,
		 int & iflag)
{
  Matrix params(n,1);
  memcpy(params.data,x,sizeof(double)*n);
  Matrix origPoints=projectPoints(non_lin_kc,non_lin_intrinsic,
				  params,non_lin_worldp);

  //lsqnonlin doesn't like nan's and infs, make 'em zero to have it
  //abort, could probably do this with iflag
  for(int i=0;i<n;i++){
    if(isinf(x[i]))x[i]=0;
    if(isnan(x[i]))x[i]=0;
  }

  for(int i=0;i<m/2;i++){
    fvec[2*i]=origPoints(0,i)-non_lin_imagep(0,i);
    fvec[2*i+1]=origPoints(1,i)-non_lin_imagep(1,i);

    if(isnan(fvec[2*i]))fvec[2*i]=10000;
    if(isnan(fvec[2*i+1]))fvec[2*i+1]=10000;
  }
}

//params is rodrigues 3 parameters, followed by the tx,ty,tz
double optimize(Matrix & kc,Matrix & intrinsic,
		Matrix & extrinsic,
		Matrix & imagep,Matrix & worldp,Matrix & params)
{
  static int which=0;
  which++;

  int npoints=worldp.n;
  //.0000001,0.0000001};
  double epsilon[6]={0.0000001,
		     0.0000001,
		     0.0000001,
		     0.0000001,
		     0.0000001,
		     0.0000001};
  Matrix p2;
  Matrix threeby1(3,1);
  double lastResidual=100000000;
  double res;
#ifdef PD
  params.printMatlab("---initial params");
#endif

#ifndef LOCAL_OPTIMIZE
  printf("about to do lsqnonlin %d %d\n",imagep.m,imagep.n);
  non_lin_imagep=imagep;
  non_lin_intrinsic=intrinsic;
  non_lin_kc=kc;
  non_lin_worldp=worldp;
  Matrix non_lin_fvec(2,imagep.n);
  Matrix::lsqnonlin(non_lin_opt,params,non_lin_fvec);
  printf("done lsqnonlin\n");
  res=non_lin_fvec.dot(non_lin_fvec);
#else
  for(int its=0;its<20;its++){
    
    Matrix origPoints=projectPoints(kc,intrinsic,params,worldp);
#ifdef PD
    if(its==0){
      worldp.transpose().print();
      origPoints.transpose().printMatlab("orig");
    }
#endif
    Matrix residual(npoints*2,1);
    Matrix J(npoints*2,6);
    
    p2=params.copy();
    for(int i=0;i<npoints;i++){
      residual.set(2*i ,0,+origPoints(0,i)-imagep(0,i));
      residual.set(2*i+1,0,+origPoints(1,i)-imagep(1,i));
    }
    res=residual.dot(residual);
    prnt("residual %f\n",res);
    
    for(int j=0;j<6;j++){
      Matrix projPoints;

      p2(j,0)=params(j,0)+epsilon[j];
      projPoints=projectPoints(kc,intrinsic,p2,worldp);
      p2(j,0)=params(j,0);
      
      for(int i=0;i<npoints;i++){
	J( 2*i, j)=projPoints(0,i)-origPoints(0,i);
	J(2*i+1,j)=projPoints(1,i)-origPoints(1,i);
      }
    }    

    //J.printMatlab("J");
    //residual.printMatlab("residual");
    Matrix rhs=residual.copy();
    rhs*=-1;
    Matrix update=Matrix::LlinLeastSq(J,rhs);

    /*
    Matrix S,V,D;
    J.svd(S,V,D);
    Matrix * check= &update;
    
    if(its==0){
      FILE * file;
      if(which!=1){
	file=fopen("latest-J.dump","rb");
	double * data = new double[check->m*check->n];
	fread(data,sizeof(double),check->m*check->n,file);
	fclose(file);

	int diff=0;
	for(int i=0;i<check->m*check->n;i++){
	  if(data[i]!=check->data[i]){
	    prnt("%d different\n",i);
	    diff++;
	  }
	}
	if(diff){
	  prnt("%d/%d different\n",diff,check->m*check->n);
	  getchar();
	}

	delete data;
      }

      file=fopen("latest-J.dump","wb");
      fwrite(check->data,sizeof(double),check->m*check->n,file);
      fclose(file);
    }
    */
    //update.transpose().printMatlab("update");
    
    double scales[]={1,0.5,0.2,0.1};
    int nscales=4;
    int converged=0;
    int sci=0;
    for(sci=0;sci<nscales;sci++){

      double updated=0;
      //prnt("update:");
      for(int i=0;i<6;i++){
	updated+=pow(update(i,0)*epsilon[i]*scales[sci],2);
	//prnt("%f ",update(i,0)*epsilon[i]*scales[sci]);
	params(i,0)=params(i,0)+update(i,0)*epsilon[i]*scales[sci];
      }
      //prnt("\n");
      //prnt("updated %f\n",sqrt(updated));
      double squp=sqrt(updated);
      if(squp<10e-5 || isnan(squp)){
	//prnt("converged\n");
	converged=1;
	break;
      }
      
      Matrix newpts=projectPoints(kc,intrinsic,params,worldp);
      Matrix residual2(npoints*2,1);
      double res2;
      for(int i=0;i<npoints;i++){
	residual2(2*i ,0)=+newpts(0,i)-imagep(0,i);
	residual2(2*i+1,0)=+newpts(1,i)-imagep(1,i);
      }
      res2=residual2.dot(residual2);
      if(res2<res){
	//prnt("okay %d\n",sci);
	break;
      }
      else{
	for(int i=0;i<6;i++){
	  params(i,0)=params(i,0)-update(i,0)*epsilon[i]*scales[sci];
	}
      }
    }     
    if(sci==nscales){
      //prnt("unable to improve\n");
    }
    //params->printMatlab("------params");
    lastResidual=res;

    if(converged)break;
  }
#endif
#ifdef PD
  params.printMatlab("params");
#endif
  /*Get the extrinsic matrix */
  //FIXME: this should be moved
  Matrix trans=Matrix::eye(4);
  Matrix rot33;
  Matrix rot44=Matrix::eye(4);
  threeby1(0,0)=params(0,0);
  threeby1(1,0)=params(1,0);
  threeby1(2,0)=params(2,0);
  
  rot33=threeby1.rod2matrix();
  for(int b=0;b<3;b++){   
    for(int h=0;h<3;h++){
      rot44(b,h)=rot33(b,h);
    }
  }
  trans(0,3)=params(3,0);
  trans(1,3)=params(4,0);
  trans(2,3)=params(5,0);
  extrinsic=trans*rot44;
  //END FIXME:

  return res/npoints;//lastResidual/npoints;
}

void drawEllipse(Matrix & ellipse){
  
  if(MIN(ellipse.m,ellipse.n)==0)return;
  glPushMatrix();
  glTranslatef(ellipse[0],ellipse[1],0);
  glRotatef(ellipse[4]*180/M_PI,0,0,1);

  double x;
  double y;
  int top=1000;
  glBegin(GL_LINE_LOOP);
  for(int i=0;i<top;i++){
    double angle=2*M_PI*((double)i/(double)top);
    
    x=ellipse[2]*cos(angle);
    y=ellipse[3]*sin(angle);
    glVertex2f(x,y);
  }
  glEnd();
  glPopMatrix();
}

Matrix fitEllipse(Matrix & points)
{
  int i=0;

  if(points.m==0){
    Matrix mat(5,0);
    mat.setAll(0);
    return mat;
  }

  Matrix D(points.m,6);
  Matrix C(6,6);
  C.setAll(0);
  C(5,5)=0;
  C(0,2)=-2;
  C(2,0)=-2;
  C(1,1)=1;

  for(i=0;i<points.m;i++){
    D(i,0)=points(i,0)*points(i,0);
    D(i,1)=points(i,0)*points(i,1);
    D(i,2)=points(i,1)*points(i,1);
    D(i,3)=points(i,0);
    D(i,4)=points(i,1);
    D(i,5)=1;
  }
  Matrix DtD=D.transpose()*D;
  Matrix rhs = DtD.inverse()*C;
  Matrix eigVal,eigVec;
  rhs.eig(eigVec,eigVal);
#ifdef PD
  eigVal.printMatlab("eigVal");
  eigVec.printMatlab("eigVec");
#endif
  
  double smallest=10e20;
  int smallesti=0;
  for(int i=0;i<eigVal.m;i++){
    if(eigVal[i]<smallest && fabs(eigVal[i])>0){
      smallest=eigVal[i];
      smallesti=i;
    }
  }
#ifdef PD
  prnt("Smallest  %d %f",smallesti,eigVal[smallesti]);
#endif
  Matrix a=eigVec.getColumn(smallesti);
#ifdef PD
  a.printMatlab("ellipse");
#endif

  double theta = 0.5*atan2(a[1],a[0]-a[2]);
  double cost=cos(theta);
  double sint=sin(theta);
  double sint2=sint*sint;
  double cost2=cost*cost;
  double Ao = a.data[5];
  double Au = a.data[3]*cost+a.data[4]*sint;
  double Av = -1*a.data[3]*sint+a.data[4]*cost;
  double Auu = a.data[0]*cost2+a.data[2]*sint2+a.data[1]*cost*sint;
  double Avv = a.data[0]*sint2+a.data[2]*cost2-a.data[1]*cost*sint;
  double tuCentre = -Au/(2.0f*Auu);
  double tvCentre = -Av/(2.0f*Avv);
  double wCentre = Ao-Auu*tuCentre*tuCentre-Avv*tvCentre*tvCentre;
  double uCentre = tuCentre*cost-tvCentre*sint;
  double vCentre = tuCentre*sint+tvCentre*cost;
  double Ru = -wCentre/Auu;
  double Rv = -wCentre/Avv;
  double Rusign=1.0f;
  double Rvsign=1.0f;
  if(Ru<0)Rusign=-1.0f;
  if(Rv<0)Rvsign=-1.0f;
  Ru = sqrt(fabs(Ru))*Rusign;
  Rv = sqrt(fabs(Rv))*Rvsign;

  Matrix ellipse(5,1);

  ellipse[0]=uCentre;
  ellipse[1]=vCentre;
  ellipse[2]=Ru;
  ellipse[3]=Rv;
  ellipse[4]=theta;
  return ellipse;
}

double calibrate(Matrix & kc,Matrix & intrinsic,
		 Matrix & extrinsic,
		 Matrix &_worldp,Matrix &_imagep,
		 int fitFocalLength)
{
  int i=0;
  if(_worldp.m<=0)return 0;
  Matrix A(2*_worldp.m,9);
  Matrix worldp,imagep;
  Matrix tempMat;
  worldp = _worldp.copy();
  imagep = Matrix(_worldp.m,3);
  

#ifdef PD
  _worldp.printMatlab("worldp");
  _imagep.printMatlab("imagep");
#endif

  for(i=0;i<worldp.m;i++){
    //worldp->set(i,0,worldp->get(i,0)/worldp->get(i,2));
    //worldp->set(i,1,worldp->get(i,1)/worldp->get(i,2));
    //worldp->set(i,2,worldp->get(i,2)/worldp->get(i,2));
    
    imagep(i,0)=_imagep(i,0);
    imagep(i,1)=_imagep(i,1);
    imagep(i,2)=1;
  }

  Matrix t_worldp = worldp.copy();
  Matrix worldMean(3,1);
  double imageMean[3];
  double worldDist=0;
  double imageDist=0;
  double root2=sqrt(2);
  
  worldMean.setAll(0);
  imageMean[0]=imageMean[1]=imageMean[2]=0;

  //find the centroid
  for(i=0;i<worldp.m;i++){
    worldMean(0,0)=worldMean(0,0)+worldp(i,0);
    worldMean(1,0)=worldMean(1,0)+worldp(i,1);
    worldMean(2,0)=worldMean(2,0)+worldp(i,2);
  }
  worldMean*=(1.0/((double)worldp.m));
  
  //translate the points to the origin defined by centroid
  //and get the average distance from the centroid
  for(i=0;i<worldp.m;i++){
    t_worldp.set(i,0,t_worldp(i,0)-worldMean(0,0));
    t_worldp.set(i,1,t_worldp(i,1)-worldMean(1,0));
    t_worldp.set(i,2,t_worldp(i,2)-worldMean(2,0));
  }

  Matrix T = t_worldp.transpose();
  Matrix TTt = T*t_worldp;
  Matrix S, U, V, rot, trans;
  TTt.svd(S,U,V);
  //prnt("U is:\n");
  //U->print();
  //prnt("V is:\n");
  //V->print();

  rot=V.transpose();
  if(rot.det()<0){
    prnt("det less than 0\n");
    rot*=-1;
  }
 
  Matrix worldp2 = rot*T;

  trans = rot*worldMean;
  trans*=-1;
  
  //prnt("worldp2 is :\n");
  //worldp2->print();
  
  Matrix H;
  Matrix worldp2t=worldp2.transpose();
  //worldp2t.print();
  Matrix normalizedImagep = intrinsic.inverse()*imagep.transpose();
  normalizedImagep=normalizedImagep.transpose();
  H=getHomography(normalizedImagep,worldp2t);  


  /*
    //NEIL, just trying to rectify the space, and then use
    //the center finding routine to find a better approximation
    //of the centers is not going to work.  You tried, but
    // warp(findcenters(image)) almost= findcenters(warp(image)) 
    //This needs to take into account the rigidity of the pattern,
    //maybe using martins suggestion of tracking..but, what
    //about occlusions, may be very expensive to perform.
    
  //new stuff
  Matrix tp(3,normalizedImagep.m);
  //tp(0,0)=0;tp(0,1)=original.w;tp(0,2)=original.w;tp(0,3)=0;
  //tp(1,0)=0;tp(1,1)=0;tp(1,2)=original.h;tp(1,3)=original.h;
  //tp(2,0)=1;tp(2,1)=1;tp(2,2)=1;tp(2,3)=1;

  for(int i=0;i<normalizedImagep.m;i++){
    tp(0,i)=imagep(i,0);
    tp(1,i)=imagep(i,1);
    tp(2,i)=1;
  }
  Matrix Hi=H.inverse()*intrinsic.inverse();
  Matrix sc=Matrix::eye(3,3);
  sc(0,0)=128;
  sc(1,1)=128;
  Hi=sc*Hi;
  Matrix Hps=Hi*tp;
  for(int i=0;i<Hps.n;i++){
    Hps(0,i)/=Hps(2,i);
    Hps(1,i)/=Hps(2,i);
    Hps(2,i)/=Hps(2,i);
  }
  double minx=Hps.minInRow(0);
  double miny=Hps.minInRow(1);
  double ox=minx-8;
  double oy=miny-8;
  Hps.transpose().printMatlab("Hps");
  Imagef cp;
  cp=original;
  Imagef Him=applyHomography(cp,Hi,ox,ox+272,oy,oy+272);
  cp.writePPM("cp.ppm");
  printf("getting dots Him.ppm");

  for(int j=0;j<Hps.n;j++){
    double x=(Hps(0,j)-ox);
    double y=(Hps(1,j)-oy);
    for(int k=-4;k<=4;k++){
      int x2=x+k;
      if(x2>=0 && y>=0 && x2<Him.width && y<Him.height){
	Him((int)x2,(int)y,2)=1;
	Him((int)x2,(int)y,0)=0;
	Him((int)x2,(int)y,1)=0;
      }
    }
    for(int k=-4;k<=4;k++){
      int y2=y+k;
      if(x>=0 && y2>=0 && x<Him.width && y2<Him.height){
	Him((int)x,(int)y2,2)=1;
	Him((int)x,(int)y2,0)=0;
	Him((int)x,(int)y2,1)=0;
      }
    }
  }
  //find new centers in this space
  double * cent;
  int edummy;
  int * sz;
  Image8 cur;
  cur=Him.getChannel(1);
  int nc=bottomup(cur,&cent,&sz,10,1000,edummy);
  Matrix tnc(2,nc);
  memcpy(tnc.data,cent,sizeof(double)*2*nc);

  for(int j=0;j<tnc.n;j++){
    double x=(tnc(0,j));
    double y=(tnc(1,j));
    for(int k=-4;k<=4;k++){
      int x2=x+k;
      if(x2>=0 && y>=0 && x2<Him.width && y<Him.height){
	Him((int)x2,(int)y,2)=1;
	Him((int)x2,(int)y,0)=1;
	Him((int)x2,(int)y,1)=1;
      }
    }
    for(int k=-4;k<=4;k++){
      int y2=y+k;
      if(x>=0 && y2>=0 && x<Him.width && y2<Him.height){
	Him((int)x,(int)y2,2)=1;
	Him((int)x,(int)y2,0)=1;
	Him((int)x,(int)y2,1)=1;
      }
    }
  }
  Him.writePPM("Him.ppm"); 
  //end new stuff */
 


  H*=(1.0/H(2,2));
#ifdef PD
  H.printMatlab("H");
#endif
  //adjust the intrinsic and H matrix for a focal length that
  //is different than the one in the F-matrix
  if(fitFocalLength)
  {
    //Can get an update of the focal length here:
    //There are two linear constraints in alpha^2,
    // dot(diag(alpha,alpha,1)*r1,diag(alpha,alpha,1)r2)=0 and
    // |diag(alpha,alpha,1)*r1|^2=|(diag(alpha,alpha,1)*r2)|^2 
    //find linear solution for alpha^2 and use it to update focal length
    Vec2f A(H(0,0)*H(0,1)+H(1,0)*H(1,1),
	    (H(0,0)*H(0,0)+H(1,0)*H(1,0)-
	     H(0,1)*H(0,1)-H(1,1)*H(1,1)));
    Vec2f b(-H(2,0)*H(2,1),H(2,1)*H(2,1)-H(2,0)*H(2,0));
    double alphasq=A.dot(b)/(A.dot(A));
    
    printf("alphasq:%f\n",alphasq);
    if(alphasq>0){
      double alpha=sqrt(alphasq);
      
      //only update if change is significant
      if((1.0/alpha) > 1.02 || (1.0/alpha)<1/1.02){
	printf("focal length should be %f (was %f)\n",
	       (intrinsic(0,0)+intrinsic(1,1))/2.0/alpha,
	       (intrinsic(0,0)+intrinsic(1,1))/2.0);

	intrinsic=intrinsic.copy();
	intrinsic(0,0)=intrinsic(0,0)/alpha;
	intrinsic(1,1)=intrinsic(1,1)/alpha;
	
	H(0,0)*=alpha;
	H(1,0)*=alpha;
	H(0,1)*=alpha;
	H(1,1)*=alpha;
      }
    }
    //End updated focal length
  }

  double scale=0;
  tempMat=H.getColumn(0);
  scale=sqrt(tempMat.dot(tempMat));
  tempMat=H.getColumn(1);
  scale+=sqrt(tempMat.dot(tempMat));
  scale/=2;
#ifdef PD
  prnt("scale:%f\n",scale);
#endif
  H*=(1.0/scale);
#ifdef PD
  H.printMatlab("afterH:\n");
#endif

  Vec3d u1(H.get(0,0),H.get(1,0),H.get(2,0));
  Vec3d u2(H.get(0,1),H.get(1,1),H.get(2,1));
  Vec3d tmp,u3;
  u1.normalize();
  tmp=u1;
  tmp.mult(u1.dot(u2));
  u2.sub(tmp);
  u2.normalize();
  u3=u1.cross(u2);

  Matrix newRot(3,3);
  Matrix newTrans(3,1);
  newRot(0,0)=u1.x;
  newRot(1,0)=u1.y;
  newRot(2,0)=u1.z;
  newRot(0,1)=u2.x;
  newRot(1,1)=u2.y;
  newRot(2,1)=u2.z;
  newRot(0,2)=u3.x;
  newRot(1,2)=u3.y;
  newRot(2,2)=u3.z;
  
  newTrans(0,0)=H(0,2);
  newTrans(1,0)=H(1,2);
  newTrans(2,0)=H(2,2);

  tempMat = newRot*trans;
  trans = tempMat;
  trans+=newTrans;

  tempMat = newRot*rot;
  rot=tempMat;
#ifdef PD
  trans.printMatlab("trans");
  rot.printMatlab("rot");
#endif
  Matrix rod = rot.matrix2rod();
  Matrix params;

  params = Matrix(6,1);
  params(0,0)=rod(0,0);
  params(1,0)=rod(1,0);
  params(2,0)=rod(2,0);
  params(3,0)=trans(0,0);
  params(4,0)=trans(1,0);
  params(5,0)=trans(2,0);
  
  Matrix ipt=imagep.transpose();
  Matrix wpt=worldp.transpose();
#ifdef PD
  params.printMatlab("Params before");
#endif
  return optimize(kc,intrinsic,extrinsic,ipt,wpt,params);
}

int calibrateGetInfo(CalibInfo & ci)
{
    if(!g_ncenters){
      prnt("no info\n");
      return 0;
    }
    ci.ncenters=g_ncenters;
    ci.nlines =g_nlines;
    ci.center[0]=g_center[0];
    ci.center[1]=g_center[1];
    
    ci.centers = new double[g_ncenters*2];
    memcpy(ci.centers,g_centers,2*sizeof(double)*ci.ncenters);
    
    ci.sizes = new int[g_ncenters];
    memcpy(ci.sizes,g_sizes,sizeof(int)*ci.ncenters);
    
    ci.labels = new int[g_nlines];
    memcpy(ci.labels,g_labels,sizeof(int)*ci.nlines);
    
    //ci.labels2 = new int[g_nlines];
    //memcpy(ci.labels2,g_labels2,sizeof(int)*ci.nlines);
    
    ci.lines = new int *[g_nlines];
    for(int i=0;i<ci.nlines;i++){
	ci.lines[i]=new int[4];
	memcpy(ci.lines[i],g_lines[i],sizeof(int)*4);
    }
    return 1;
}

void calibrateRelease()
{
  if(g_ncenters){
      for(int i=0;i<g_nlines;i++){
	  delete [] g_lines[i];
      }
    delete [] g_centers;
    delete [] g_sizes;
    delete [] g_labels;
    delete [] g_lines;
    delete [] g_labels2;

    g_ncenters=0;
    g_nlines=0;

    g_centers=0;
    g_sizes=0;
    g_labels=0;
    g_lines=0;
    g_center[0]=0;
    g_center[1]=0;
  }
}
//#define USE_FIND_CENTERS
/**
 * Calibrate the image using the given threshold and camera
 * parameters.
 * \param orig The input image to calibrate
 * \param rt The red threshold
 * \param gt The green threshold
 * \param bt The blue threshold
 * \param small The minimum size of a region
 * \param large The maximum size of a region
 * \param useautothresh If on, bottomup is used to find the regions
 * \param kc The distortion coefficients of the camera that took the image
 * \param intrinsic The intrinsic coefficients of the camera
 * \param extrinsic The output variable containing the calibration of the camera
 * \param fitFocalLength Flag whether to fit the focal length.
 * \return The normalized residual 
 */
double calibrateImage(Image8 & orig,int rt,int gt,
		      int bt,int smallSize,
		      int large,int useautothresh,
		      Matrix & kc,Matrix & intrinsic,Matrix & extrinsic,
		      int fitFocalLength)
{
   double t[3];
   Matrix worldp, imagep, center;

   original=orig;

   if(!useautothresh){
     //current = original.getChannel(1);
     //g_ncenters=bottomup(current,&g_centers,&g_sizes,smallSize,large,gt);
     t[0]=rt;t[1]=gt;t[2]=bt;
     current = original.threshLess(t)*255;
     g_ncenters=findCenters(current,&g_centers,&g_sizes,smallSize,large);
   }
   else{
     int edummy;
     int channel=0;
     if(gt<rt)channel=1;
     if((channel==1 && bt<gt)||
	(channel==0 && bt<rt))channel=2;
     current = original.getChannel(channel);
     g_ncenters=bottomup(current,&g_centers,&g_sizes,smallSize,large,edummy);
   }
   g_nlines=findLines(g_centers,g_sizes,g_ncenters,&g_lines);
   printf("after findLines, found %d lines (%d centers)\n",g_nlines,g_ncenters);
   //After commenting this out it seemed to be better for some sequences.
   removeBadLines(g_centers,g_sizes,g_ncenters,
	  	  g_lines,&g_nlines);
   
   //double remove_this;
   center=findCenterOfPattern(g_centers,g_sizes,g_ncenters,
			      g_lines,&g_nlines);//,&remove_this,-1);//no removal of lines
   g_labels=orderLines(g_centers,g_sizes,g_ncenters,
		       g_lines,g_nlines,center);
   prnt("%f %f %f ncenters: %d\n",t[0],t[1],t[2],g_ncenters);
   /*New
    */
   Matrix points1=Matrix(g_nlines,2);
   Matrix points2=Matrix(g_nlines,2);
   for(int i=0;i<g_nlines;i++){
       points1(i,0)=g_centers[g_lines[i][0]];
       points1(i,1)=g_centers[g_lines[i][0]+g_ncenters];
       
       points2(i,0)=g_centers[g_lines[i][3]];
       points2(i,1)=g_centers[g_lines[i][3]+g_ncenters];
       
   }
   g_ellipse1=fitEllipse(points1);
   g_ellipse2=fitEllipse(points2);
   //end new ellipse stuff
   
   g_labels2 = labelLines2();

   int * ignore=new int[g_nlines];
   memset(ignore,0,sizeof(int)*g_nlines);

   groupToPoint(g_centers,g_sizes,g_ncenters,g_lines,
		g_nlines,g_labels,ignore,worldp,imagep);
   Matrix intr_copy=intrinsic.copy();
   double residual=calibrate(kc,intr_copy,extrinsic,
			     worldp,imagep,fitFocalLength);
   
   int ignored=1;
   while(ignored){
     ignored=0;
     for(int i=0;i<g_nlines;i++){
       if(!ignore[i]){
	 ignore[i]=1;
	 groupToPoint(g_centers,g_sizes,g_ncenters,g_lines,
		      g_nlines,g_labels,ignore,worldp,imagep);
	 Matrix intr_copy=intrinsic.copy();
	 double res=calibrate(kc,intr_copy,extrinsic,
			      worldp,imagep,fitFocalLength);
	 printf("if ignore %d, %f<%f\n",i,res,residual);
	 if(res*5<residual){
	   printf("ignoring %d, %f<%f\n",i,res,residual);
	   residual=res;
	   ignored++;
	 }
	 else
	   ignore[i]=0;
       }
     }
   }

   //Remove the ignored
   for(int i=g_nlines-1;i>=0;i--){
     if(ignore[i]){
       g_nlines--;
       delete [] g_lines[i];
       for(int j=i;j<g_nlines;j++){
	   ignore[j]=ignore[j+1];
	   g_lines[j]=g_lines[j+1];
	   g_labels[j]=g_labels[j+1];
       }
       ignore[i]=0;
     }
   }

   groupToPoint(g_centers,g_sizes,g_ncenters,g_lines,
		g_nlines,g_labels,ignore,worldp,imagep);
   residual=calibrate(kc,intrinsic,extrinsic,
		      worldp,imagep,fitFocalLength);//intrinsic may change here, hence no intrinsic.copy()
     
   g_center[0]=center[0];
   g_center[1]=center[1];
   delete [] ignore;
   return residual;
}

#ifdef USE_DISPLAY_HELPER
void displayHelper()
{
  glClear(GL_COLOR_BUFFER_BIT);

  GLuint tex[2];
  glGenTextures(2,tex);

  int nearestw=1;
  int nearesth=1;
  float wratio=1;
  float hratio=1;
  while(nearestw<original.width){
    nearestw*=2;
  }
  while(nearesth<original.height){
    nearesth*=2;
  }
  wratio=(float)original.width/(float)nearestw;
  hratio=(float)original.height/(float)nearesth;
  
  
  unsigned char * data = new unsigned char[nearestw*nearesth*3];

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,tex[0]);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexEnvf(GL_TEXTURE_2D,GL_TEXTURE_ENV_MODE,GL_DECAL);

  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,
	       nearestw,
	       nearesth,
	       0,GL_RGB,GL_UNSIGNED_BYTE,data);
  glTexSubImage2D(GL_TEXTURE_2D,0,
		  0,0,
		  original.width,
		  original.height,
		  GL_RGB,GL_UNSIGNED_BYTE,original.data);
  glBindTexture(GL_TEXTURE_2D,tex[1]);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexEnvf(GL_TEXTURE_2D,GL_TEXTURE_ENV_MODE,GL_DECAL);

  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,
	       nearestw,
	       nearesth,
	       0,GL_RGB,GL_UNSIGNED_BYTE,data);
  glTexSubImage2D(GL_TEXTURE_2D,0,
		  0,0,
		  original.width,
		  original.height,
		  GL_LUMINANCE,GL_UNSIGNED_BYTE,current.data);

  
  glLoadIdentity();

  glColor3f(1.0,1.0,1.0);
  glBindTexture(GL_TEXTURE_2D,tex[0]);
  glBegin(GL_QUADS);
  glTexCoord2f(0,0);glVertex2f(0,0);
  glTexCoord2f(wratio,0);glVertex2f(original.width,0);
  glTexCoord2f(wratio,hratio);glVertex2f(original.width,original.height);
  glTexCoord2f(0,hratio);glVertex2f(0,original.height);
  glEnd();

  glTranslatef(original.width,0,0);
  glBindTexture(GL_TEXTURE_2D,tex[1]);
  glBegin(GL_QUADS);
  glTexCoord2f(0,0);glVertex2f(0,0);
  glTexCoord2f(wratio,0);glVertex2f(original.width,0);
  glTexCoord2f(wratio,hratio);glVertex2f(original.width,original.height);
  glTexCoord2f(0,hratio);glVertex2f(0,original.height);
  glEnd();

  delete [] data;
  glDeleteTextures(2,tex);
  glDisable(GL_TEXTURE_2D);

  glPointSize(4);
  glColor3f(0.0,1.0,0.0);
  for(int i=0;i<g_ncenters;i++){
    drawString(g_centers[i],g_centers[i+g_ncenters],"%d",i);
      //glVertex2d(centers[i],centers[i+ncenters]);
      //prnt("%d %f %f\n",i,centers[i],centers[i+ncenters]);
  }
  //glEnd();

  glColor3f(1.0,0.0,0.0);
  for(int i=0;i<g_nlines;i++){
      int biggest=g_sizes[g_lines[i][0]];
      if(g_sizes[g_lines[i][1]]>biggest)
	  biggest=g_sizes[g_lines[i][1]];
      if(g_sizes[g_lines[i][2]]>biggest)
	  biggest=g_sizes[g_lines[i][2]];
      if(g_sizes[g_lines[i][3]]>biggest)
	  biggest=g_sizes[g_lines[i][3]];
      int middle=(int)(0.75*biggest);

      for(int j=0;j<4;j++){
	  if(g_sizes[g_lines[i][j]]>middle){
	    glColor3f(0.2,0.2,0.6);
	    glPointSize(3);
	  }
	  else{
	    glColor3f(0.8,1.0,0.8);
	    glPointSize(3);
	  }
	  glBegin(GL_POINTS);
	  glVertex2d(g_centers[g_lines[i][j]],
		     g_centers[g_lines[i][j]+g_ncenters]);
	  glEnd();
	  
      }
      glLineWidth(2);
      glColor3f(0.6,0.6,0.6);
      glBegin(GL_LINES);
      glVertex2d(g_centers[g_lines[i][0]],
		 g_centers[g_lines[i][0]+g_ncenters]);
      glVertex2d(g_centers[g_lines[i][3]],
		 g_centers[g_lines[i][3]+g_ncenters]);
      glEnd();

      if(!g_labels){
	drawString(g_centers[g_lines[i][3]],
		   g_centers[g_lines[i][3]+g_ncenters],
		   "    %d\n",i);
      }
      else{
	if(g_labels[i]!=g_labels2[i])
	  glColor3f(0.1,1.0,0.1);
	else
	  glColor3f(0.0,1.0,1.0);
	drawString(g_centers[g_lines[i][3]],
		   g_centers[g_lines[i][3]+g_ncenters],
		   "   %d,%d,%d",i,g_labels[i],g_labels2[i]);
      }
      prnt("%d:%d,%d:%d,%d:%d,%d:%d\n",
	     g_lines[i][0],g_sizes[g_lines[i][0]],
	     g_lines[i][1],g_sizes[g_lines[i][1]],
	     g_lines[i][2],g_sizes[g_lines[i][2]],
	     g_lines[i][3],g_sizes[g_lines[i][3]]);
  }

  glBegin(GL_POINTS);
  glColor3f(0.0,0.0,1.0);
  glVertex2f(g_center[0],g_center[1]);
  glEnd();
  
  if(MIN(g_ellipse1.m,g_ellipse1.n)){
      glTranslatef(-original.width,0,0);
    drawEllipse(g_ellipse1);
    //getchar();
    
    glColor3f(1.0,0.0,0.0);
    glPushMatrix();
    glTranslatef(g_ellipse1[0],g_ellipse1[1],0);
    glRotatef(g_ellipse1[4]*180.0/M_PI,0,0,1);
    
    for(int i=0;i<15;i++){
      double angle=startAngle+2*M_PI*(double)i/15.0;
      double x=cos(angle)*g_ellipse1[2];
      double y=sin(angle)*g_ellipse1[3];
    glPointSize(6);
    glBegin(GL_POINTS);
    glVertex2f(x,y);
    glEnd();
    
    }
    glPopMatrix();
  }
  drawEllipse(g_ellipse2);
}
#endif

namespace NewSeg{
/**
 * Container class for maintaining information about regions for bottomup().
 * Maintains the center and size (and past centers and sizes) for 
 * a segmented region.  
 */
class Region{
public:
  Vec2d lastCenter;
  Vec2d center;
  int size;
  int * indptr;
  int hasntmoved;
  int * prevsizes;
  Vec2d * prevcenters;
  int used;
  int maxhistory;
  Region(){
    size=0;
    center=Vec2d(0,0);
    indptr=0;
    hasntmoved=0;
    used=-1;
    maxhistory=4;
    prevsizes=new int[maxhistory];
    prevcenters=new Vec2d[maxhistory];
  }
  Region(const Region & r){
    size=0;
    center=Vec2d(0,0);
    indptr=0;
    hasntmoved=0;
    used=-1;
    maxhistory=4;
    prevsizes=new int[maxhistory];
    prevcenters=new Vec2d[maxhistory];
    operator=(r);
  }
  ~Region(){
    delete [] prevsizes;
    delete [] prevcenters;
    maxhistory=0;
  }
  void operator=(const Region & r){
    ensureHistory(r.hasntmoved);
    lastCenter=r.lastCenter;
    center=r.center;
    size=r.size;
    indptr=r.indptr;
    hasntmoved=r.hasntmoved;
    used=r.used;
    memcpy(prevsizes,r.prevsizes,sizeof(int)*r.hasntmoved);
    memcpy(prevcenters,r.prevcenters,sizeof(Vec2d)*r.hasntmoved);
  }
  void ensureHistory(int n){
    while(n>=maxhistory){
      int * newprevsizes = new int[maxhistory*2];
      Vec2d * newprevcenters = new Vec2d[maxhistory*2];
      memcpy(newprevsizes,prevsizes,sizeof(int)*maxhistory);
      memcpy(newprevcenters,prevcenters,sizeof(Vec2d)*maxhistory);
      delete [] prevsizes;
      delete [] prevcenters;
      prevsizes=newprevsizes;
      prevcenters=newprevcenters;
      maxhistory*=2;
    }
  }
  void saveCenter(){
    lastCenter=center*(1.0/(double)size);
  }
  int updateHasntMoved(){
    if((lastCenter-(center*(1.0/(double)size))).len()<1){
      ensureHistory(hasntmoved);
      prevsizes[hasntmoved]=size;
      prevcenters[hasntmoved]=(center*(1.0/(double)size));
      hasntmoved++;
    }
    else{
      hasntmoved=0;
    }
    return hasntmoved;
  }
};
}
/**
 * Helper function for merging regions in bottomup, do not call this directly.
 * \param queue input memory to use for queue, must be large enough
 * \param labels integer labels for each pixel
 * \param nlabels total number of labels
 * \param regions the integer label for a pixel can be dereferenced to index the associated region that the pixel belongs to
 * \param w the widht of the image (and the labels 2d array)
 * \param h the height of the image (and the labels 2d array)
 * \param x the x location of the pixel to merge 
 * \param y the y location of the pixel to merge
 * \param x1 the x location of the other region to merge
 * \param y1 the y location of the other region to merge
 * \sa bottomup 
 */
int * bu_merge(int * queue,int ** labels,int & nlabels,
	       NewSeg::Region * regions,
	       int w,int h,int x,int y,int x1,int y1)
{
  
  int * from=labels[y1*w+x1];
  int * to=labels[y*w+x];
  //its less work to change the labels of the
  //smaller region
  if(regions[*to].size<regions[*from].size){
    int * temp;
    temp=from;
    from=to;
    to=temp;
  }
  int head=0;
  int tail=0;
  //printf("merging %d,%p into %d,%p\n",*from,from,
  // *to,to);
  //A couple sanity checks
  if(from==to || *from==*to){
    printf("exiting, from==to==%d\n",*from);
    exit(0);
  }
  if(regions[*from].size==0){
    printf("exiting size[%d]==0\n",*from);
    exit(0);
  }
  //  printf("sizes from:%d, to:%d\n",
  // regions[*from].size,
  // regions[*to].size);

  //update the sizes and centers
  int set=0;
  int fromsize=regions[*from].size;
  regions[*to].center+=regions[*from].center;
  regions[*from].center=Vec2d(0,0);
  regions[*to].size+=regions[*from].size;
  regions[*from].size=0;

  queue[tail++]=y*w+x;
  if(labels[y*w+x]==from)set++;
  labels[y*w+x]=to;

  //Do a BFS through the from region and set
  //the labels to "to"
  while((tail-head)>0){
    int cur=queue[head++];
    y=cur/w;
    x=cur-y*w;
    if(x>0 && labels[y*w+x-1]==from){
      labels[y*w+x-1]=to;
      queue[tail++]=y*w+x-1;
      set++;
    }
    if(y>0 && labels[(y-1)*w+x]==from){
      labels[(y-1)*w+x]=to;
      queue[tail++]=(y-1)*w+x;
      set++;
    }
    if(x<w-1 && labels[y*w+x+1]==from){
      labels[y*w+x+1]=to;
      queue[tail++]=y*w+x+1;
      set++;
    }
    if(y<h-1 && labels[(y+1)*w+x]==from){
      labels[(y+1)*w+x]=to;
      queue[tail++]=(y+1)*w+x;
      set++;
    }
  }
  //Another sanity check
  if(set!=fromsize){
    int found=0;
    for(int i=0;i<w*h;i++){
      if(labels[i]==from)found++;
    }
    printf("set=%d!=%d=fromsize\n",set,fromsize);
    printf("found %d that didn't go\n",found);
    exit(0);
  }
  //Swapping the from region with the last region
  //allows for the number of labels to be decremented
  NewSeg::Region regionBack;
  regionBack=regions[*from];
  regions[nlabels-1].indptr[0]=*from;
  regions[*from]=regions[nlabels-1];

  delete regionBack.indptr;
  regionBack.indptr=0;
  nlabels--;

  return to;
}

/**
 * Find centers in a gray scale image, no threshold necessary.
 * To avoid using a threshold to obtain a b/w image, bottomup
 * detects the regions using every possible threshold, and maintains
 * the regions that do not move much from one threshold to the next.
 * This is done efficiently by storing the pixel locations by gray
 * scale value.  
 * \param im the input gray-scale image to find centers in
 * \param cntrs the centers of the detected regions
 * \param szs the sizes of the detected regions
 * \param minsize the minimum size of region to accept
 * \param maxsize the maximum size of region to accept
 * \param threshold will be set to the optimal threshold for the image
 * \return the number of centers detected
 * \sa findCenters
 */
int bottomup(Image8 & im,double ** cntrs,int ** szs,
	      int minsize,int maxsize,int & threshold)
{
  int index=0;
  if(im.nchannels>1){
    printf("Only accept 1 channel images\n");
  }
  //indicesbygray tells which pixel has color c...
  //maxs[i] is the size of indicesbygray[i]
  //and cnts[i] is the number of elements in indicesbygray[i]
  unsigned int * indicesbygray[256];
  int  maxs[256];
  int  cnts[256];

  //the maximum memory allocated for regions,
  // the regions, and the number of regions (nlabels)
  int maxregions;
  NewSeg::Region * regions;
  int nlabels;

  // A pointer to integer for each pixel in the image,
  // which when dereferenced gives the index into regions.
  // The pointer is used to allow easy reordering of the
  // regions when merging.
  int ** labels;

  //Some extra memory allocated for the merging of two regions
  //if w*h units are allocated, it is impossible for normal
  //execution to run out.
  int * queue; 

  //Growable temporary variables that hold the output
  //before it is in the true output format
  int maxcenters=32;
  Vec2d * centers = new Vec2d[maxcenters];
  int * sizes = new int[maxcenters];
  int ncenters=0;

  if(index==0){
    for(int i=0;i<256;i++){
      maxs[i]=32;
      cnts[i]=0;
      indicesbygray[i]=new unsigned int[maxs[i]];
    }
    for(int i=0;i<im.h;i++){
      for(int j=0;j<im.w;j++){
	int col=im(j,i);
	if(cnts[col]>=maxs[col]){
	  int newmax=(maxs[col]*2);
	  unsigned int * newindices=new unsigned int[newmax];
	  memcpy(newindices,indicesbygray[col],sizeof(unsigned int)*maxs[col]);
	  maxs[col]=newmax;
	  delete indicesbygray[col];
	  indicesbygray[col]=newindices;
	}
	indicesbygray[col][cnts[col]++]=i*im.w+j;
      }
    }
    nlabels=0;
    labels = new int *[im.w*im.h];
    
    maxregions = 128;
    regions = new NewSeg::Region[maxregions];
   
    queue = new int[im.w*im.h];
    memset(labels,0,sizeof(int*)*im.w*im.h);
  }
  //Keep track of the best possible threshold for
  //this image.
  int bestnvotes=0;
  int bestthresh=0;
  /*
    For each intensity value, and all the pixels of that
    intensity value to the current regions.  Keep track
    of any regions that have not moved over different
    iterations and return these regions
  */ 
  for(int i=index;i<256;i++){
    for(int k=0;k<cnts[i];k++){
      int y=indicesbygray[i][k]/im.w;
      int x=indicesbygray[i][k]-y*im.w;
      int * lab=0;
      int * lastset=0;
      NewSeg::Region * region=0;
      /*if(labels[y*im.w+x]){
	printf("label is already set!!, exiting\n");
	exit(0);
	}*/
      if(y>0){
	if(lab=labels[(y-1)*im.w+x]){
	  region=regions+*lab;
	  region->size++;
	  region->center+=Vec2d(x,y);
	  labels[y*im.w+x]=lab;
	  lastset=lab;
	}
      }
      if(x>0){
	if(lab=labels[y*im.w+x-1]){  
	  if(lastset && lastset!=lab){
	    lab=bu_merge(queue,labels,nlabels,
			 regions,im.w,im.h,x,y,x-1,y);
	  }
	  else if(lastset!=lab){
	    region=regions+*lab;
	    region->size++;
	    region->center+=Vec2d(x,y);
	  }
	  labels[y*im.w+x]=lab;
	  lastset=lab;
	}
      }
      if(y<im.h-1){
	if(lab=labels[(y+1)*im.w+x]){
	  if(lastset && lastset!=lab){
	    lab=bu_merge(queue,labels,nlabels,
			 regions,im.w,im.h,x,y,x,y+1);
	  }
	  else if(lastset!=lab){
	    region=regions+*lab;
	    region->size++;
	    region->center+=Vec2d(x,y);
	  }
	  labels[y*im.w+x]=lab;
	  lastset=lab;
	}
      }
      if(x<im.w-1){
	if(lab=labels[y*im.w+x+1]){
	  if(lastset && lastset!=lab){
	    lab=bu_merge(queue,labels,nlabels,
			 regions,im.w,im.h,x,y,x+1,y);
	  }
	  else if(lastset!=lab){
	    region=regions+*lab;
	    region->size++;
	    region->center+=Vec2d(x,y);
	  }
	  labels[y*im.w+x]=lab;
	  lastset=lab;
	}
      }
      if(lastset==0){
	if(nlabels>=maxregions){
	  NewSeg::Region * newregions = new NewSeg::Region[maxregions*2];
	  //memcpy(newregions,regions,maxregions*sizeof(Region));
	  for(int r=0;r<nlabels;r++){
	    newregions[r]=regions[r];
	  }
	  delete [ ] regions;
	  regions=newregions;
	  maxregions*=2;
	}
	int * anint = new int[1];
	anint[0]=nlabels;
	nlabels++;
	labels[y*im.w+x]=anint;
	regions[anint[0]].hasntmoved=0;
	regions[anint[0]].center=Vec2d(x,y);
	regions[anint[0]].size=1;
	regions[anint[0]].indptr=anint;
	regions[anint[0]].used=-1;
      }
    }
    int votes=0;
    if(i==0){
      for(int j=0;j<nlabels;j++){
	regions[j].saveCenter();
      }
    }
    else{
      for(int j=0;j<nlabels;j++){
	if(regions[j].size>=minsize &&
	   regions[j].size<maxsize)
	  regions[j].updateHasntMoved();
	regions[j].saveCenter();

	if(regions[j].hasntmoved>=20 &&
	   regions[j].hasntmoved<100){
	  if(ncenters>=maxcenters){
	    Vec2d * newcenters = new Vec2d[maxcenters*2];
	    int * newsizes = new int[maxcenters*2];
	    memcpy(newcenters,centers,maxcenters*sizeof(Vec2d));
	    memcpy(newsizes,sizes,maxcenters*sizeof(int));
	    delete [] centers;
	    delete [] sizes;
	    centers=newcenters;
	    sizes=newsizes;
	    maxcenters*=2;
	  }
	  if(regions[j].used==-1){
	    centers[ncenters]=regions[j].center*(1.0/regions[j].size);
	    sizes[ncenters]=regions[j].size;
	    regions[j].used=ncenters;
	    ncenters++;
	  }
	  else{
	    int where=regions[j].used;
	    Vec2d meancenter(0,0);
	    int meansize=0;
	    int bottom=regions[j].hasntmoved/4;
	    int top=regions[j].hasntmoved-bottom;
	    int used=0;
	    for(int k=bottom;k<top;k++){
	      meansize+=regions[j].prevsizes[k];
	      meancenter+=regions[j].prevcenters[k];
	      used++;
	    }
	    //centers[where]=regions[j].center*(1.0/regions[j].size);
	    //sizes[where]=regions[j].prevsizes[regions[j].hasntmoved/2];
	    //centers[where]=regions[j].prevcenters[regions[j].hasntmoved/2];
	    //regions[j].size;
	    centers[where]=meancenter*(1.0/used);
	    sizes[where]=meansize/used;
	  }
	  votes++;
	}
      }
    }
    if(votes>bestnvotes){
      bestnvotes=votes;
      bestthresh=i;
    }
  }
  threshold=bestthresh;

  //Copy the output into the output variables
  *cntrs = new double[ncenters*2];
  *szs = new int[ncenters];

  for(int i=0;i<ncenters;i++){
    (*cntrs)[i]=centers[i].x;
    (*cntrs)[i+ncenters]=centers[i].y;
    (*szs)[i]=sizes[i];
  }
  /*  Imagef imf(im.w,im.h,3);
  for(int i=0;i<im.w*im.h;i++){
    if(labels[i]==0){
      imf[3*i+0]=0;
      imf[3*i+1]=0;
      imf[3*i+2]=0.2;
    }
    else{
      int l=*labels[i];;
      imf[3*i+0]=(float)l/(float)nlabels;
      imf[3*i+1]=(float)l/(float)nlabels;
      imf[3*i+2]=(float)l/(float)nlabels;
    }
  }
  for(int i=0;i<nlabels;i++){
    if(regions[i].size>10){
      int x=regions[i].center.x/(double)regions[i].size;
      int y=regions[i].center.y/(double)regions[i].size;
      if(x>=0 && y>=0 && x<im.w && y<im.h){
	imf(x,y,0)=1.0;
	imf(x,y,1)=1.0;
	imf(x,y,2)=0.0;
      }
    }
    }*/
  delete [] centers;
  delete [] sizes;
  for(int i=0;i<nlabels;i++)
    delete regions[i].indptr;
  delete [] regions;
  delete [] labels;
  delete [] queue;
  for(int i=0;i<256;i++){
    delete indicesbygray[i];
  }
  index=0;
  return ncenters;
}

#ifdef NEWSEG_MAIN

/**
 * Display function for standalone program.
 */
void display()
{
  /*
  glClear(GL_COLOR_BUFFER_BIT);
  Image8 seg=original.getChannel(1);
  //Imagef imf=  
  GLuint tex[1];
  glGenTextures(1,tex);
   
  double wratio;
  double hratio;
  glColor3f(1.0,1.0,1.0);
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,tex[0]);
  //seg=imf;
  //imf.initTextureNoResize(&wratio,&hratio);
  seg.initTextureNoResize(&wratio,&hratio);
  glBegin(GL_QUADS);
  glTexCoord2f(0,0);glVertex2f(0,0);
  glTexCoord2f(wratio,0);glVertex2f(original.width,0);
  glTexCoord2f(wratio,hratio);glVertex2f(original.width,original.height);
  glTexCoord2f(0,hratio);glVertex2f(0,original.height);
  glEnd();
  
  glDeleteTextures(1,tex);
  g_ncenters=bottomup(seg,&g_centers,&g_sizes,10,1000);
  */
  calibrateImage(original,thresh,thresh,thresh,15,1000,1,
		 g_kc,g_intrinsic,g_extrinsic);
  displayHelper();
  calibrateRelease();
  glutSwapBuffers();

  glutPostRedisplay();
}

void keys(unsigned char c,int x,int y)
{
  switch(c){
  case 27:
    prnt("%d matrices left to delete\n",
	   Matrix::gcount);
    exit(0);
  case '+':
    thresh++;
    break;
  case '-':
    thresh--;
    break;
  }
  glutPostRedisplay();
}


void init()
{

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glViewport(0,0,ww,wh);
  glOrtho(0,ww,wh,0,-1,1);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
 
}

void calibInit(char * fname)
{
  double fx=363.0017;//413.1795329561925;
  double fy=363.5357;//413.3604660994160;
  double px=152.360809036324;
  double py=113.112125563360;

  g_kc[0]=-0.40743818922655;
  g_kc[1]=0.53393818146118;
  g_kc[2]=0.00036239062064;
  g_kc[3]=-0.00380086091997;
  g_kc[4]=0;

  g_intrinsic(0,0)=fx;
  g_intrinsic(1,1)=fy;
  g_intrinsic(0,2)=px;
  g_intrinsic(1,2)=py;
#ifdef PD
  g_intrinsic.print();
#endif
  original.read(fname);
  //imageInit(&current,original.width,original.height);

  ww=original.width*2;
  wh=original.height;
}
#endif

#ifdef FROM_FILE

int main(int ac,char ** av)
{
  calibInit(av[1]);
  Matrix imagep;
  Matrix worldp;
  Matrix p(6,1);
  if(ac>1){
    FILE * file;
    file = fopen(av[1],"r");

    int npoints;
    int i=0;
    fscanf(file,"%d",&npoints);
    for(i=0;i<6;i++){
      float f;
      fscanf(file,"%f",&f);
      prnt("%f\n",f);
      p[i]=f;
    }
    imagep=Matrix(npoints,3);
    imagep.setAll(1);
    worldp=Matrix(npoints,3);

    for(i=0;i<npoints;i++){
      for(int j=0;j<2;j++){
	float f;
	fscanf(file,"%f",&f);
	imagep(i,j)=f;
      }
    }

    for(i=0;i<npoints;i++){
      for(int j=0;j<3;j++){
	float f;
	fscanf(file,"%f",&f);
	worldp(i,j)=f;
      }
    }

    fclose(file);
  }
  else
    return 0;
  
  Matrix imagept=imagep.transpose();
  Matrix worldpt=worldp.transpose();
  //calibrate(worldp,imagep);
#ifdef PD
  p.print();
  imagep.printMatlab("imagep");
  worldp.printMatlab("worldp");
#endif
  double res=optimize(imagept,worldpt,p);
  prnt("Residual %f\n",res);
  return 0;
}
#endif

#ifdef NEWSEG_MAIN
int main(int ac,char ** av)
{
  glutInit(&ac,av);

  glutInitDisplayMode(GLUT_RGBA|GLUT_DOUBLE|GLUT_DEPTH);

  calibInit(av[1]);

  glutInitWindowSize(ww,wh);
  glutCreateWindow("dots");

  glutKeyboardFunc(keys);
  glutDisplayFunc(display);
 
  init();

  Matrix mat(2,2);
  Matrix a,b,c(6,1);

  mat(0,0)=2;
  mat(0,1)=1;
  mat(1,0)=1;
  mat(1,1)=1;
  mat.svd(a,b,c);
#ifdef PD
  a.print();
  b.print();
  c.print();
#endif
  //delete a;
  //delete b;
  //delete c;
  //delete mat;

  prnt("-----------after:%d-----------\n",Matrix::gcount);
  mat=Matrix::random(100,100);
  mat.svd(a,b,c);

  //b.print();

  //Matrix * trans = mat->transpose();
  //mat=trans->mult(mat);
  //mat->eig(&a,&b);

  glutMainLoop();

}
#endif
