#include <GL/gl.h>
#include <GL/glut.h>
#include <GL/glu.h>
#include "image.h"
#include "matrix.h"
#include "clb.h"
#include "mesh.h"


/*
  ./ray -dir out -file image-%04d.tga -nrays 64 -nimages 32 -sx  23.0000 -sy  23.0000 -sz  23.0000 -tx  -0.000 -ty  -0.0000 -tz  -0.000 -ofile geom.obj

 */
void keys(unsigned char c,int x,int y);
namespace render{
Image8 image;
int bdown=0;
int mpos[2];
int draw=0;
}
using namespace render;
Vec3f cpos=Vec3f(0,0,-600);
Vec3f crot(0,0,0);

int gindex=0;
int writing=0;
GLuint targetTex;
int nimages=32;
Mesh mesh;
int getimage=0;

void motion(int x,int y){
  float dx=mpos[0]-x;
  float dy=mpos[1]-y;
  if(bdown==1){
    crot[0]+=dy*0.1;
    crot[1]+=dx*0.1;
  }
  if(bdown==2){
    cpos[0]+=dx*0.1;
    cpos[1]+=-dy*0.1;
  }
  if(bdown==3){
    cpos[2]+=dy*0.1;
  }
  mpos[0]=x;
  mpos[1]=y;
  glutPostRedisplay();
}

void mouse(GLint button,GLint state,int x,int y){
    
    if(state==GLUT_DOWN){
	bdown=button+1;
    }
    else bdown=0;
    
    mpos[0]=x;
    mpos[1]=y;
    glutPostRedisplay();
}

void display(){
    static int writeCount=0;
    glEnable(GL_NORMALIZE);
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glLoadIdentity();
    glTranslatef(cpos[0],cpos[1],cpos[2]);
    glRotatef(crot[0],1,0,0);
    glRotatef(crot[1],0,1,0);
    
    glDisable(GL_LIGHTING);
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,targetTex);
    glScalef(30,30,30);
    /*glColor3f(0.0,1.0,0.0);
    glBegin(GL_QUADS);
    glTexCoord2f(0,0);glVertex3f(-10,0,-10);
    glTexCoord2f(0,1);glVertex3f(-10,0, 10);
    glTexCoord2f(1,1);glVertex3f( 10,0, 10);
    glTexCoord2f(1,0);glVertex3f( 10,0,-10);
    glEnd();*/
    glDisable(GL_TEXTURE_2D);
   

    //glEnable(GL_TEXTURE_2D);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);
    glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER,1);

    float pos[]={0,100,0,1};
    glPushMatrix();
    glLoadIdentity();
    glLightfv(GL_LIGHT0,GL_POSITION,pos);
    glPopMatrix();

    float spec[]={0.5,0.5,0.5,1.0};
    float diff[]={0.7,0.0,0.0,1.0};
    float amb[]={0.0,0.0,0.0,1.0};
    glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,spec);
    glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,diff);
    glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,amb);
    glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,100);
    
    glColor3f(1.0,1.0,1.0);
    glPushMatrix();
    //glTranslatef(0,2,0);
    //glRotatef(90,1,0,0);
    //mesh.draw();
    //glutSolidTorus(0.8,2.0,100,100);
    glutSolidSphere(2.0,100,100);
    //glutSolidCube(1.0);
    glPopMatrix();
    
    diff[0]=0;
    diff[1]=0;
    diff[2]=1;
    /*
    glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,diff);
    glPushMatrix();
    glTranslatef(0.75,0.0,0.3);
    //glRotatef(-90,1,0,0);
    glutSolidCone(0.5, 1.0,40,40);
    glPopMatrix();
 
    glPushMatrix();
    glTranslatef(-0.75,0.3,0.0);
    glRotatef(-90,1,0,0);
    glutSolidCone(0.5, 1.0,40,40);
    glPopMatrix();*/
    //glColor3f(1.0,1.0,1.0);
    //glutSolidTeapot(1);

    if(writing || getimage){
      Image8 im(320,240,3);
      Image8 im2(320,240,4);
      glReadPixels(0,0,320,240,GL_RGB,
		   GL_UNSIGNED_BYTE,im.getDataPtr());
      char filename[256];
      
      for(int i=0;i<240;i++){
	for(int j=0;j<320;j++){
	  im2(j,i,0)=im(j,240-i-1,0);
	  im2(j,i,1)=im(j,240-i-1,1);
	  im2(j,i,2)=im(j,240-i-1,2);
	  im2(j,i,3)=(!(im2(j,i,1)>250 && (im(j,240-i-1,2)<5) &&
		      (im(j,240-i-1,0)<5)))*255;
	}
      }
      
      sprintf(filename,"out/image-%04d.tga",gindex);
      im2.writeTGA(filename);
      
      glPushMatrix();
      glLoadIdentity();
      glScalef(1,-1,1);
      glTranslatef(cpos[0],cpos[1],cpos[2]);
      glRotatef(crot[0],1,0,0);
      glRotatef(crot[1],0,1,0);

      double mat[16];
      glGetDoublev(GL_MODELVIEW_MATRIX,mat);
      glPopMatrix();

      double angle=atan2(mat[10],mat[2]);
      if(angle<0)angle+=2*M_PI;
      printf("angle is %f (should be %f)\n",180.0*angle/M_PI,
	     crot[1]);
      
      char cfname[1024];
      sprintf(cfname,"out/image-%04d.tga.clb",gindex);
      
      FILE * f=fopen(cfname,"wb");
      CalibInfo ci;
      Matrix intr(3,3);
      Matrix extr(4,4);
      Matrix proj(3,4);
      Matrix dist(5,1);
      intr.setAll(0);
      proj.setAll(0);
      memcpy(extr.data,mat,sizeof(double)*16);
      extr=extr.transpose();
      extr.printMatlab("extr");
      proj(0,0)=proj(1,1)=proj(2,2)=1;
      /*
	Focal Length:          fc = [ 449.23900   450.30121 ]  [ 1.94412   3.01548 ]
	Principal point:       cc = [ 155.70633   115.73798 ]  [ 4.94659   3.10119 ]
	Skew:             alpha_c = [ 0.00000 ]  [ 0.00000  ]   => angle of pixel axes = 90.00000  0.00000 degrees
	Distortion:            kc = [ -0.00053   -0.33230   -0.00197   -0.00204  0.00000 ]  [ 0.03945   0.49336   0.00243   0.00364  0.00000 ]
	Pixel error:          err = [ 0.16300   0.12362 ]
      */
      
      intr(0,0)=intr(1,1)=1000;
      intr(0,2)=160;
      intr(1,2)=120;
      intr(2,2)=1;
      dist[0]=-0.00053;
      dist[1]=-0.3323;
      dist[2]=-0.00197;
      dist[3]=-0.00204;
      dist[4]=0;
      
      writeCLB(f,HAS_EXTRINSIC|HAS_INTRINSIC|HAS_MASK,
		 intr,extr,proj,dist,ci);
      fclose(f);
      
      //fwrite(ext,8,16,calibFile);
      
      if(writeCount<nimages && !getimage){
	crot[1]+=360.0/nimages;
      }
      glutPostRedisplay();
      
      writeCount++;
      gindex++;
      if(writeCount==nimages){
	writing=0;
      }
      getimage=0;
    }
    else writeCount=0;
    glutSwapBuffers();
}

void keys(unsigned char c,int x,int y){
    static int which=0;
   
    switch(c){
    case 'i':
      getimage=1;
      glutPostRedisplay();
      break;
      
    case 'w':
      image = Image8(256,256,3);
      writing=1;
      glutPostRedisplay();
      break;
    }
    which++;
}

void init(int ac,char * av[]){
  Image8 im;
  if(im.read("target.tga")){
    glEnable(GL_TEXTURE_2D);
    glGenTextures(1,&targetTex);
    glBindTexture(GL_TEXTURE_2D,targetTex);
    
    im.initTexture();
    glDisable(GL_TEXTURE_2D);
  }
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(30,(double)320/(double)240,100,10000);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glClearColor(0.0,1.0,0.0,0.0);
  if(ac>1){
    printf("loading...result:%d\n",mesh.loadLWO(av[1]));
    mesh.setScale(Vec3f(10,10,10));
    mesh.setPos(Vec3f(0,0.5,0));
  }
  else
    mesh.loadMD2("/home/birkbeck/test2/test/models/r2d2.md2",
		 "/home/birkbeck/test2/test/models/r2d2.ppm");
  mesh.setScale(Vec3f(2,2,2));
  mesh.setPos(Vec3f(-2,0,0));

  //float col[]={1.0,1.0,1.0,1.0};
  //mesh.setSurf(0,col);
}

int main(int ac,char * av[]){
  glutInit(&ac,av);
  glutInitDisplayMode(GLUT_DEPTH|GLUT_DOUBLE);
  
  glutInitWindowSize(320,240);
  
  glutCreateWindow("window");
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keys);
  glutDisplayFunc(display);
  
  glEnable(GL_DEPTH_TEST);
  init(ac,av);
  
  glutMainLoop();
  return 0;
}




