#include "chart.h"
#include "matrix.h"
#include <GL/gl.h>
#include <GL/glut.h>
#include "image.h"

float findNearest(Image8 & im,int off,Image32 & closest,Imagef & distance)
{
  distance=Imagef(im.w,im.h,1);
  closest=Image32(im.w,im.h,1);
  distance=(double)im.w*im.h;
  closest=0;
  int di=0;
  int * queue = new int[im.w*im.h];
  int * inq = new int[im.w*im.h];
  int ninq=0;
  
  int * queue2 = new int[im.w*im.h];
  int * inq2 = new int[im.w*im.h];
  int ninq2=0;
  float root2=sqrt(2);
  int eightneigh=1;
  memset(queue,0,sizeof(int)*im.w*im.h);
  memset(inq,0xFF,sizeof(int)*im.w*im.h);
  memset(queue2,0,sizeof(int)*im.w*im.h);
  memset(inq2,0xFF,sizeof(int)*im.w*im.h);

  for(int i=0;i<im.h;i++){
    for(int j=0;j<im.w;j++){
      if(im(j,i)!=off){
	int ioff[]={0,0,1,-1,1,1,-1,-1};
	int joff[]={-1,1,0,0,-1,1,-1,1};
	float ds[]={1,1,1,1,root2,root2,root2,root2};
	for(int k=0;k<8;k++){
	  int i2=i+ioff[k];
	  int j2=j+joff[k];
	  if(i2>=0 && j2>=0 &&
	     i2<im.h && j2<im.w){
	    int index2=i2*im.w+j2;
	    if(ds[k]<distance(j2,i2)){
	      if(inq2[index2]==-1){
		inq2[index2]=ninq2;
		queue2[ninq2++]=index2;
	      }
	      closest(j2,i2)=i*im.w+j;
	      distance(j2,i2)=ds[k];
	    }
	  }
	  closest(j,i)=i*im.w+j;
	  distance(j,i)=0;
	}
      }
    }
  }
  di=1;
  while(ninq2){
    ninq=ninq2;
    ninq2=0;

    int * qback=queue;
    queue=queue2;    
    queue2=qback;
   
    int * inqback=inq;
    inq=inq2;
    inq2=inqback;

    ninq2=0;
    memset(inq2,0xFF,sizeof(int)*im.w*im.h);//this prbly isn't necessary but to be safe
    
    while(ninq){
      int index=queue[--ninq];
      int i=index/im.w;
      int j=index-im.w*i;
      int ioff[]={0,0,1,-1,1,1,-1,-1};
      int joff[]={-1,1,0,0,-1,1,-1,1};
      float ds[]={1,1,1,1,root2,root2,root2,root2};

      for(int k=0;k<8;k++){
	int i2=i+ioff[k];
	int j2=j+joff[k];
	if(i2>=0 && j2>=0 &&
	   i2<im.h && j2<im.w){
	  int index2=i2*im.w+j2;
	  if((distance(j,i)+ds[k])<distance(j2,i2) /*&& inq2[index2]==-1*/){
	    if(inq2[index2]==-1){
	      inq2[index2]=ninq2;
	      queue2[ninq2++]=index2;
	    }
	    closest(j2,i2)=closest(j,i);
	    distance(j2,i2)=ds[k]+distance(j,i);
	  }
	}
      }
      inq[index]=0;
    }
    printf("Distance %d, %d\n",di,ninq2);
    di++;
  }
  
  float maxdist=0;
  for(int i=0;i<im.w*im.h;i++){
    if(distance[i]>maxdist && distance[i]<im.w*im.h)maxdist=distance[i];
  }
  return maxdist;
  /*
  printf("maxdist %f\n",maxdist);
  Image8 dscale(im.w,im.h,1);
  for(int i=0;i<im.h;i++){
    for(int j=0;j<im.w;j++){
      dscale(j,i)=(unsigned char)(255.0f*(float)distance(j,i)/(float)maxdist);
    }
  }dscale.writePPM("dscale.ppm");
  
  int nbad=0;
  for(int i=0;i<im.w*im.h;i++){
    if(distance[i]>=im.w*im.h){
      nbad++;
      closest[i]=0;
    }
  }
  if(nbad)
    printf("FIXME: nbad = %d (index out of bounds for map)\n",nbad);
  //return dscale;
  //return distance;
  //return closest;*/
}

Chart chart;
void disp()
{
  static GLuint tex;
  static int cnt=0;
  if(cnt==0){
    glGenTextures(1,&tex);
    cnt=1;
  }
  glClearColor(0.0,0.0,0.0,0.0);
  glClear(GL_COLOR_BUFFER_BIT);

  glColor3f(1.0,1.0,1.0);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  float minx=2,miny=2;
  float maxx=-2,maxy=-2;
  for(int i=0;i<chart.nvert;i++){
    minx=MIN(chart.tc[i].x,minx);
    miny=MIN(chart.tc[i].y,miny);
    maxx=MAX(chart.tc[i].x,maxx);
    maxy=MAX(chart.tc[i].y,maxy);
  }
  //glOrtho(minx-0.1,maxx+0.1,miny-0.1,maxy+0.1,-1,1);
  glOrtho(0,1,0,1,-1,1);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glDisable(GL_BLEND);
  chart.drawTC();
  Image8 im(512,512,1);
  glBindTexture(GL_TEXTURE_2D,tex);
  im.initTexture();

  glReadPixels(0,0,512,512,GL_RED,GL_UNSIGNED_BYTE,im.data);
  Image32 closest;
  Imagef distance;
  printf("finding nearest\n");
  float maxdist=findNearest(im,0,closest,distance);
  distance/=maxdist;
  printf("done finding nearest\n");
  im.writePPM("tris.ppm");
  distance.writePPM("distance.ppm");

  //,Image32 & closest,Imagef & distance)

  glClearColor(0.4,0.4,0.6,0.0);
  glClear(GL_COLOR_BUFFER_BIT);

  glDrawPixels(im.w,im.h,GL_LUMINANCE,GL_FLOAT,
	       distance.data);

  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  glColor4f(1.0,1.0,1.0,0.5);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  chart.drawTC();
  glDisable(GL_BLEND);
  glColor4f(1.0,1.0,1.0,1.0);
  glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
  chart.drawTC();
  int * border;
  int nborder=chart.getBorder(&border);
  
  if(nborder){
    Chart borderChart;
    int nvert=0;
    int * map = new int[chart.nvert];
    memset(map,0xff,sizeof(int)*chart.nvert);
    for(int i=0;i<nborder;i++){
      if(map[border[2*i]]==-1)
	map[border[2*i]]=nvert++;
      if(map[border[2*i+1]]==-1)
	map[border[2*i+1]]=nvert++;
    }
    printf("nborder: %d, nvert: %d\n",nborder,nvert);
    borderChart.init(2*nvert,2*nvert);
    memset(borderChart.tc,0,sizeof(Vec2f)*2*nvert);
    int pi=0;
    for(int i=0;i<nborder;i++){
      borderChart.vert[map[border[2*i]]]=chart.vert[border[2*i]];
      borderChart.vert[map[border[2*i+1]]]=chart.vert[border[2*i+1]];
      borderChart.tc[map[border[2*i]]]=chart.tc[border[2*i]];
      borderChart.tc[map[border[2*i+1]]]=chart.tc[border[2*i+1]];
      borderChart.poly[pi][0]=map[border[2*i]];
      borderChart.poly[pi][1]=map[border[2*i+1]];
      borderChart.poly[pi][2]=nvert+map[border[2*i+1]];
      pi++;
      borderChart.poly[pi][0]=map[border[2*i]];
      borderChart.poly[pi][1]=nvert+map[border[2*i+1]];
      borderChart.poly[pi][2]=nvert+map[border[2*i]];
      pi++;

      Vec2f norm;
      norm=borderChart.tc[map[border[2*i+1]]]-borderChart.tc[map[border[2*i]]];
      norm.normalize();
      norm.rotate(-M_PI/2.0);
      borderChart.tc[nvert+map[border[2*i]]]+=(norm)*0.5;
      borderChart.tc[nvert+map[border[2*i+1]]]+=(norm)*0.5;
    }
    for(int i=0;i<nvert;i++){
      Vec2f pt=borderChart.tc[i];
      Vec2f dir=borderChart.tc[nvert+i];
      pt.x*=im.w;
      pt.y*=im.h;
      borderChart.tc[nvert+i].normalize();
      //dir.mult(1.0/512.0);//one pixel long
      int j=0;
      double dist=0;
      int x=pt.x;
      int y=pt.y;
      float dx;
      float dy;
      int bad=0;
      
      int temp=1;
      
      while(temp<4){
	if(distance(x-temp,y)>0){
	  dx=(distance(x,y)-distance(x-temp,y))/temp;
	  break;
	}
	else if(distance(x+temp,y)>0){
	  dx=(distance(x+temp,y)-distance(x,y))/temp;
	  break;
	}
	temp++;
      }
      if(temp==4)bad=1;

      while(temp<4){
	if(distance(x,y-temp)>0){
	  dy=(distance(x,y)-distance(x,y-temp))/temp;
	  break;
	}
	else if(distance(x,y+temp)>0){
	  dy=(distance(x,y+temp)-distance(x,y))/temp;
	  break;
	}
	temp++;
      }
      if(temp==4)bad=1;

      dx=(distance(x+1,y)-distance(x-1,y))/2.0;
      dy=(distance(x,y+1)-distance(x,y-1))/2.0;

      Vec2f otherdir(dx,dy);
      otherdir.normalize();
      printf("dx,dy: %f %f\n",dx,dy);

      if(!bad){
	dir=Vec2f(dx,dy);
	dir.normalize();
      }
      else{
	dir=Vec2f(0,0);
      }
	
      for(j=0;j<=40;j++){
	double newdist;
	int x=pt.x;
	int y=pt.y;
	if(x>=0 && y>=0 && x<im.w && y<im.h){
	  newdist=distance(x,y);
	  if(newdist<dist && j>=4){
	    printf("%f < %f\n",newdist,dist);
	    break;
	  }
	  if(dist==0 && j!=0)
	    break;
	  dist=newdist;
	  pt=pt+dir;
	}
	else break;
      }
      borderChart.tc[nvert+i]=Vec2f((float)pt.x/(float)im.w,
				    (float)pt.y/(float)im.h);
    }
    /*
    for(int i=0;i<nvert;i++){
      borderChart.tc[nvert+i].normalize();
      borderChart.tc[nvert+i].mult(4.0/256.0);
      borderChart.tc[nvert+i]+=borderChart.tc[i];
      }*/
    printf("pi: %d\n",pi);
    glLineWidth(1);
    glColor3f(1.0,0.0,0.0);
    delete map;
    
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
    glColor4f(1.0,0.0,0.0,0.5);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    borderChart.drawTC();
    glDisable(GL_BLEND);
    glColor4f(1.0,0.0,0.0,1.0);
    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    borderChart.drawTC();
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

    
    for(int k=0;k<nvert;k++){      
      float x=borderChart.tc[k].x;
      float y=borderChart.tc[k].y;
      int i=(int)(y*im.h);
      int j=(int)(x*im.w);
      
      glColor3f(0.0,0.0,1.0);
      glBegin(GL_LINES);
      glVertex2f(x,y);
      float dx=(distance(j+1,i)-distance(j-1,i))/2.0;
      float dy=(distance(j,i+1)-distance(j,i-1))/2.0;
      Vec2f d(dx,dy);
      
      d.normalize();
      d*=32.0/512.0;
      Vec2f pnt(x+d.x,y+d.y);
      glVertex2f(pnt.x,pnt.y);
      glEnd();
    }

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0,1,0,1,-1,1);


    /*
    int space=16;
    for(int i=space/2;i<512;i+=space){
      for(int j=space/2;j<512;j+=space){
	float x=j;
	float y=i;
	glColor3f(1.0,0.0,0.0);
	glBegin(GL_LINES);
	glVertex2f(x/512.0f,y/512.0f);
       	float dx=(distance(j,i)-distance(j-1,i));
	float dy=(distance(j,i)-distance(j,i-1));
	Vec2f d(dx,dy);
	
	d.normalize();
	d*=(space-1);
	Vec2f pnt(x+d.x,y+d.y);
	glVertex2f(pnt.x/512.0f,pnt.y/512.0f);
	glEnd();
	
	glColor3f(0.0,0.0,1.0);
	glBegin(GL_POINTS);
	glVertex2f(x/512.0f,y/512.0f);
	glEnd();
      }
      }*/
    
  }

  glutSwapBuffers();
}


int main(int ac,char * av[])
{
  if(ac>1){
    chart.loadobj(av[1]);
  }
  glutInit(&ac,av);
  glutInitDisplayMode(GLUT_RGB|GLUT_DOUBLE);
  glutInitWindowSize(512,512);
  glutCreateWindow("win");
 
  glutDisplayFunc(disp);
    
  glutMainLoop();
  return 0;
}
