#ifndef COMPLEX_H
#define COMPLEX_H

template <class T>
class complex{
public:
  T real;
  T imag;
  complex(){
    real=0;
    imag=0;
  }
  complex(const double &d){
    real=d;
    imag=0;
  }
  complex(T r,T i){
    real=r;
    imag=i;
  }
  complex operator+(const T & c){
    return complex(real+c,
		   imag);
  }
  complex operator-(const T & c){
    return complex(real-c,
		   imag);
  }
  complex operator*(const T & c){
    return complex(real*c,
		   imag*c);
  }
  complex operator/(const T & c){
    return complex(real/c,
		   imag/c);
  }
  
  
  complex operator+(const complex & o){
    return complex(real+o.real,
		   imag+o.imag);
  }
  complex operator-(const complex & o){
    return complex(real-o.real,
		   imag-o.imag);
  }
  void operator+=(const complex & o){
    real+=o.real;
    imag+=o.imag;
  }
  void operator-=(const complex & o){
    real-=o.real;
    imag-=o.imag;
  }
  complex operator*=(const complex & o){
    complex c=(*this)*o;
    *this=o;
  }
  void operator/=(const complex & o){
    complex c=(*this)*o.inv;
    *this=c;
  }
  complex operator*(const complex & o){
    return complex(real*o.real-imag*o.imag,
		   real*o.imag+imag*o.real);
  }
  complex operator/(const complex & o){
    return (*this)*o.inv;    
  }
  double len(){
    return sqrt(real*real+imag*imag);
  }
  complex inv(){
    double n=real*real+imag*imag;
    return complex(real/n,-imag/n);
  }
};

#endif
