#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <GLee.h>
#include <GL/gl.h>
#include "mc.h"

//extern bad;
#ifdef DEFINE_TEST
extern int current; //used in the test, should be extern if its there
#endif
int tri[5][3][2];

int table[256][8];
int triangles[256][5][3][2];
int ntriangles[256];

int ntri;
int pt2mid[][2]={{0,1},
		 {1,2},
		 {2,3},
		 {3,0},
		 {0,4},
		 {1,5},
		 {2,6},
		 {3,7},
		 {4,5},
		 {5,6},
		 {6,7},
		 {7,4}};
int syms[12][8]={{1,2,3,0,5,6,7,4},//rot y-axis
		 {2,3,0,1,6,7,4,5},
		 {3,0,1,2,7,4,5,6},
		 {3,2,6,7,0,1,5,4},//rot x-axis
		 {7,6,5,4,3,2,1,0},
		 {4,5,1,0,7,6,2,3},
		 {1,5,6,2,0,4,7,3},//rot z-axis
		 {5,4,7,6,1,0,3,2},
		 {4,0,3,7,5,1,2,6},
		 {4,5,6,7,0,1,2,3},//reflect
		 {1,0,3,2,5,4,7,6},
		 {3,2,1,0,7,6,5,4}};

//  3-2
//0-1 |
//| | 6 
//4-5
//
int getIndex(int * comb)
{
    int index=(comb[0]*1+
	       comb[1]*2+
	       comb[2]*4+
	       comb[3]*8+
	       comb[4]*16+
	       comb[5]*32+
	       comb[6]*64+
	       comb[7]*128);
    return index;
}
void invMap(int * inv,int * map)
{
    for(int i=0;i<8;i++)
	inv[map[i]]=i;
}

int baseCombination(int * comb)
{
    int index=getIndex(comb);
    return baseCombination(index);
}


int setTri(int index,int v1,int v2,int v3)
{
    memcpy(tri[index][0],pt2mid[v1],sizeof(int)*2);
    memcpy(tri[index][1],pt2mid[v2],sizeof(int)*2);
    memcpy(tri[index][2],pt2mid[v3],sizeof(int)*2);
}

int baseCombination(int comb)
{
    switch(comb){
    case 0:
      ntri=0;
      break;
    case 1:
      setTri(0,3,4,0);
      ntri=1;
      break;
    case 3:
      setTri(0,4,5,3);
      setTri(1,3,5,1);
      ntri=2;
      break;
    case 33:
      setTri(0,4,0,3);
      setTri(1,5,8,9);
      ntri=2;
      break;
    case 14:
      setTri(0,0,5,3);
      setTri(1,3,5,7);
      setTri(2,7,5,6);
      ntri=3;
      break;
    case 15:
      setTri(0,4,5,7);
      setTri(1,7,5,6);
      ntri=2;
      break;
    case 30:
      setTri(0,3,0,5);
      setTri(1,3,5,7);
      setTri(2,7,5,6);
      setTri(3,4,11,8);//changed jun sum
      ntri=4;
      break;
    case 165:
      setTri(0,4,0,3);
      setTri(1,5,8,9);
      setTri(2,11,7,10);
      setTri(3,1,6,2);
      ntri=4;
      break;
    case 141:
      setTri(0,11,4,10);
      setTri(1,4,0,10);
      setTri(2,0,6,10);
      setTri(3,0,1,6);
      ntri=4;
      break;
    case 142:
      setTri(0,3,0,11);
      setTri(1,11,0,6);
      setTri(2,11,6,10);
      setTri(3,6,0,5);
      ntri=4;
      break;
    case 65:
      setTri(0,4,0,3);
      setTri(1,10,6,9);
      ntri=2;
      break;
    case 67:
      setTri(0,4,5,3);
      setTri(1,3,5,1);
      setTri(2,10,6,9);
      ntri=3;
      break;
    case 82:
      setTri(0,11,8,4);
      setTri(1,10,6,9);
      setTri(2,5,1,0);
      ntri=3;
      break;
    case 85:
      setTri(0,11,8,3);
      setTri(1,8,0,3);
      setTri(2,10,2,9);
      setTri(3,2,1,9);
      ntri=4;
      break;
    case 77:
      setTri(0,7,4,0);
      setTri(1,7,0,9);
      setTri(2,10,7,9);
      setTri(3,9,0,1);
      ntri=4;
      break;
    //extra cases
    case 143:
      setTri(0,4,5,11);
      setTri(1,5,6,11);
      setTri(2,11,6,10);
      ntri=3;
      break;
    case 203:
      setTri(0,4,5,2);
      setTri(1,2,5,1);
      setTri(2,11,4,9);
      setTri(3,4,2,9);
      setTri(4,2,6,9);
      ntri=5;
      break;
    case 207:
      setTri(0,4,5,11);
      setTri(1,11,5,9);
      ntri=2;
      break;
    case 173:
      setTri(0,4,0,11);
      setTri(1,11,0,10);
      setTri(2,10,0,1);
      setTri(3,10,1,6);
      setTri(4,8,9,5);
      ntri=5;
      break;
    case 175:
      setTri(0,4,8,6);
      setTri(1,8,9,6);
      setTri(2,10,4,6);
      setTri(3,11,4,10);
      ntri=4;
      break;
    case 235:
      setTri(0,11,8,4);
      setTri(1,6,1,2);
      ntri=2;
      break;
    case 239:
      setTri(0,4,8,11);
      ntri=1;
      break;
    case 255:
      ntri=0;
      break;

    default:
      ntri=0;
      return 0;
    }
    return 1;
}

void apply(int * res,int * map,int * input)
{
    res[0]=input[map[0]];
    res[1]=input[map[1]];
    res[2]=input[map[2]];
    res[3]=input[map[3]];
    res[4]=input[map[4]];
    res[5]=input[map[5]];
    res[6]=input[map[6]];
    res[7]=input[map[7]];
}	
   
int combination(int * comb,int * map,int * reverse)
{
    int comb2[8];
    int comb3[8];
    int eye[8];
    
    for(int i=0;i<8;i++){
	eye[i]=i;
    }
    if(baseCombination(comb)){
	memcpy(map,eye,sizeof(int)*8);
	return 1;
    }
    for(int i=0;i<9;i++){
	apply(comb2,syms[i],comb);
	apply(map,syms[i],eye);
	(*reverse)=(i>=9);
	if(baseCombination(comb2)){
	  return 1;
	}
	for(int j=0;j<9;j++){
	  (*reverse)=((j<9)&&(i>=9))||((i<9)&&(j>=9));
	  apply(comb3,syms[j],comb2);
	  if(baseCombination(comb3)){
	    int temp[8];
	    apply(temp,syms[j],map);
	    memcpy(map,temp,sizeof(int)*8);
	    return 1;
	  }
	}
    }
    return 0;
}

void buildTable()
{
  for(int i=0;i<256;i++){
    int comb[8];
    int reverse=0;
    for(int j=0;j<8;j++){
      comb[j]= ((i & (1<<j))>0);
    }
    if(!combination(comb,table[i],&reverse)){
      printf("fatal error building table in MC\n");
      exit(0);
    }
    ntriangles[i]=ntri;
    memcpy(triangles[i],tri,sizeof(tri));
  }
}

void marchingCubesTest(Cubable & c,int nraysets)
{
#ifdef DEFINE_TEST
    int comb[8];
    int mapping[8];
    int succ=0;
    int s;
    int reverse;
    for(int i=0;i<256;i++){
	for(int j=0;j<8;j++){
	    comb[j]=((i&(1<<j))>0);
	}
	if(getIndex(comb)!=i){
	    printf("fuck %d\n",getIndex(comb));
	}
	s=combination(comb,mapping,&reverse);
	if(!s){
	    for(int j=0;j<8;j++)
		comb[j]=!comb[j];
	    s=combination(comb,mapping,&reverse);
	}
	int temp[8];
	int tempmap[8];
	apply(temp,mapping,comb);
	if(!baseCombination(temp)){
	    printf("map did not work\n");
	}
	succ+=s;
    }

    int testBase[]={0,1,3,33,14,15,30,165,141,142,65,67,82,85,77};
    double vert[][3]={{0,0,0},
		      {1,0,0},
		      {1,0,-1},
		      {0,0,-1},
		      {0,1,0},
		      {1,1,0},
		      {1,1,-1},
		      {0,1,-1}};
    
    int lines[]={0,1,2,3,0,4,5,1,5,6,2,6,7,3,7,4};
    int nlines=16;
    
    for(int j=0;j<8;j++){
	comb[j]=((testBase[current]&(1<<j))>0);
    }
    s=combination(comb,mapping,&reverse);
    
    glPointSize(20);
    glBegin(GL_POINTS);
    for(int j=0;j<8;j++){
	if(j==0)glColor3f(1.0,0.0,0.0);
	else if(j==1)glColor3f(0.0,1.0,0.0);
	else if(j==4)glColor3f(0.0,0.0,1.0);
	else glColor3f(1.0,1.0,1.0);
	glVertex3dv(vert[j]);
    }
    glEnd();
    glPointSize(1);
    
    glBegin(GL_LINE_LOOP);
    for(int j=0;j<nlines;j++){
	glVertex3dv(vert[lines[j]]);
    }
    glEnd();
    
    glColor4f(1.0,1.0,0.0,0.2);
    glBegin(GL_TRIANGLES);
    for(int i=0;i<ntri;i++){
	for(int j=0;j<3;j++){
	    Vec3f pt1(vert[tri[i][j][0]][0],
		     vert[tri[i][j][0]][1],
		     vert[tri[i][j][0]][2]);
	    Vec3f pt2(vert[tri[i][j][1]][0],
		     vert[tri[i][j][1]][1],
		     vert[tri[i][j][1]][2]);
	    pt1.add(pt2);
	    pt1.mult(0.5);
	    glVertex3fv(&pt1.x);
	}
    }
    glEnd();
    glColor3f(1.0,1.0,1.0);
    //printf("Succ %d/%d\n",succ,256);
#endif
}


int checkVertGrid(int * vertGrid,Vec3f * vert,int nvert,
		  Vec3f & point,int vi1,int vi2,double mindist)
{
  int d;
  int c;
  vi1*=12;
  vi2*=12;
  
  for(d=0;d<12;d++){
    Vec3f diff;
    if(vertGrid[vi1+d]!=-1){
      diff=point;
      diff.sub(vert[vertGrid[vi1+d]]);
      if(diff.len()<mindist){
	c=vertGrid[vi1+d];
	break;
      }
    }
    if(vertGrid[vi2+d]!=-1){
      diff = point;
      diff.sub(vert[vertGrid[vi2+d]]);
      if(diff.len()<mindist){
	c=vertGrid[vi2+d];
	break;
      }
    }
  }
  if(d==12){
    c=nvert;
    
    for(d=0;d<12;d++){
      if(vertGrid[vi1+d]==-1){
	vertGrid[vi1+d]=c;
	break;
      }
    }
    if(d==12){
      printf("too many in vertGrid\n");
    }
    for(d=0;d<12;d++){
      if(vertGrid[vi2+d]==-1){
	vertGrid[vi2+d]=c;
	break;
      }
    }
    if(d==12){
      printf("too many in vertGrid\n");
    }   
  }
  return c;
  /*
    for(c=0;c<*nvert;c++){
    Vec3f diff = point;
    diff.sub((*vert)[c]);
    if(diff.len()<mindist){
    break;
    }
    }*/
}

void ensureEnoughPolys(_3ints ** poly,const int & checkfor,int & maxpoly)
{
  if(checkfor>=maxpoly){
    _3ints * newPoly=new _3ints[maxpoly+512];
    memcpy(newPoly,*poly,sizeof(_3ints)*maxpoly);
    maxpoly+=512;
    delete *poly;
    *poly=newPoly;
    printf("allocating more polys\n");
  }
}

void addVert(Vec3f ** vert,int * nvert,int & maxvert,int c,Vec3f & point)
{  			
  if(c==*nvert){
    if(c>=maxvert){
      Vec3f * newvert = new Vec3f[maxvert+512];
      memcpy(newvert,*vert,sizeof(Vec3f)*maxvert);
      maxvert=maxvert+512;
      delete *vert;
      *vert=newvert;
      printf("allocating more vert\n");
    }
    (*nvert)++;
    (*vert)[c]=point;
  }
}


int marchingCubes(Cubable & c,_3ints ** poly,Vec3f ** vert,int * nvert,Vec3f ** norm,double mindist)
{
  static int count=0;
  int w=c.getWidth();
  int h=c.getHeight();
  int d=c.getDepth();
  printf("%d %d %d\n",w,h,d);
  char * grid=new char[w*h*d];
  double x,y,z;
  int set=0;
  memset(grid,0,w*h*d);
  int xi;
  int yi;
  int zi;
  int nbad=0;
  int solout=1;
  for(xi=0;xi<w;xi++){
    for(yi=0;yi<h;yi++){
      for(zi=0;zi<d;zi++){
	grid[zi*w*h+
	     yi*w+xi]=c.inside(xi,yi,zi);
	if(solout&&(xi==0||yi==0||zi==0||
		    xi==w-1||yi==h-1||zi==h-1)){
	  grid[zi*w*h+
	       yi*w+xi]=0;
	}
	set++;
      }
    }
  }
  if(count==0){
    buildTable();
    count=1;
  }
  //printf("set %d/%d\n",set,NRAYS*NRAYS*NRAYS);
  
  int i;
  int j;
  int k;
  int comb[8];
  int mapping[8];
  int invMapping[8];
  int succ;
  
  *nvert=0;
  int maxvert=128;
  int * vertGrid=new int[12*w*h*d];
  memset(vertGrid,-1,sizeof(int)*12*w*h*d);
  
  (*vert)=new Vec3f[maxvert];
  
  int npoly=0;
  int maxpoly=128;
  (*poly)=new _3ints[maxpoly];
  
  for(k=0;k<d-1;k++){
    for(i=0;i<h-1;i++){
      for(j=0;j<w-1;j++){
	int reverse=0;
	int pts[][3]={{0,0,0},
		      {1,0,0},
		      {1,0,1},
		      {0,0,1},
		      {0,1,0},
		      {1,1,0},
		      {1,1,1},
		      {0,1,1}};
	
	comb[0]=grid[k*w*h+i*w+j];
	comb[1]=grid[k*w*h+i*w+j+1];
	comb[2]=grid[(k+1)*w*h+i*w+j+1];
	comb[3]=grid[(k+1)*w*h+i*w+j];
	comb[4]=grid[k*w*h+(i+1)*w+j];
	comb[5]=grid[k*w*h+(i+1)*w+j+1];
	comb[6]=grid[(k+1)*w*h+(i+1)*w+j+1];
	comb[7]=grid[(k+1)*w*h+(i+1)*w+j];
	int index=getIndex(comb);
	memcpy(mapping,table[index],sizeof(int)*8);
	ntri=ntriangles[index];
	memcpy(tri,triangles[index],sizeof(tri));
	/*
	succ=combination(comb,mapping,&reverse);
	if(!succ){
	  printf("did not find it\n");
	  for(int a=0;a<8;a++)comb[a]=!comb[a];
	  succ=combination(comb,mapping,&reverse);
	  reverse=!reverse;
	  //for(int a=0;a<8;a++)comb[a]=!comb[a];
	}
	if(!succ){
	  printf("did not find it %d %d %d: ",i,j,k);
	  for(int a=0;a<8;a++)printf("%d ",comb[a]);
	  printf("\n");
	  }*/
	for(int a=0;a<8;a++){
	  if(comb[a]==0){
	    //printf("something outside %d %d %d\n",j,i,k);
	  }
	}
	ensureEnoughPolys(poly,npoly+ntri,maxpoly);
	
	for(int a=0;a<ntri;a++){
	  for(int b=0;b<3;b++){
	    int i1=mapping[tri[a][b][0]];
	    int i2=mapping[tri[a][b][1]];
	    Vec3f point;
	    Vec3f pt1((double)(j+pts[i1][0]),
		      (double)(i+pts[i1][1]),
		      (double)(k+pts[i1][2]));
	    Vec3f pt2((double)(j+pts[i2][0]),
		      (double)(i+pts[i2][1]),
		      (double)(k+pts[i2][2]));
	    
	    int succ=c.getBoundaryPoint(pt1,pt2,
					comb[i1],comb[i2],point);
	    if(!succ){
	      //succ=getBoundaryPoint2(raysets,pt1,pt2,
	      //comb[i1],comb[i2],point);
	      //if(succ)succ=0;
	      //else succ=1;
	    }
	    /*
	      glPointSize(2);
	      glColor3f(0.0,0.0,1.0);
	      glBegin(GL_POINTS);
	      glVertex3fv(point.data);
	      glEnd();
	    */
	    
	    int c=0;
	    if(mindist==0)
	      c=*nvert;
	    else{
	      int vi1=(j+pts[i1][0])+
		(i+pts[i1][1])*w+
		(k+pts[i1][2])*w*h;
	      int vi2=(j+pts[i2][0])+
		(i+pts[i2][1])*w+
		(k+pts[i2][2])*w*h;
	      int d=0;
	      c=checkVertGrid(vertGrid,*vert,*nvert,point,
			      vi1,vi2,mindist);
	    }
	    addVert(vert,nvert,maxvert,c,point);
	    (*poly)[npoly][b]=c;
	    
	    if(!succ){
	      //bad[c]=1;
	      nbad++;
	    }
	  }
	  if(reverse){
	    int temp = (*poly)[npoly][0];
	    (*poly)[npoly][0]=(*poly)[npoly][1];
	    (*poly)[npoly][1]=temp;
	  }
	  if((*poly)[npoly][0]==
	     (*poly)[npoly][1] ||
	     (*poly)[npoly][0]==
	     (*poly)[npoly][2] ||
	     (*poly)[npoly][1]==
	     (*poly)[npoly][2]){
	  }
	  else
	    npoly++;
	}
      }   
    }
  }
  
    int * edges2add = new int[(*nvert)];
    int * edges = new int[(*nvert)*12];
    int stride=12;
    memset(edges2add,-1,sizeof(int)*(*nvert));
    memset(edges,-1,sizeof(int)*(*nvert)*12);
    for(int i=0;i<npoly;i++){
      for(int j=0;j<12;j++)
	if(edges[(*poly)[i][0]*stride+j]==-1){
	  edges[(*poly)[i][0]*stride+j]=(*poly)[i][1];
	  break;
	}
      for(int j=0;j<12;j++)
	if(edges[(*poly)[i][1]*stride+j]==-1){
	  edges[(*poly)[i][1]*stride+j]=(*poly)[i][2];
	  break;
	}
      for(int j=0;j<12;j++)
	if(edges[(*poly)[i][2]*stride+j]==-1){
	  edges[(*poly)[i][2]*stride+j]=(*poly)[i][0];
	  break;
	}
    }
    for(int i=0;i<*nvert;i++){
      for(int j=0;j<12;j++){
	int to=edges[i*stride+j];
	int foundopp=0;
	if(to==-1)break;
	for(int j2=0;j2<12;j2++){
	  int to2=edges[to*stride+j2];
	  if(to2==i){
	    foundopp=1;
	    break;
	  }
	  if(to2==-1)break;
	}
	if(!foundopp){
	  if(edges2add[i]!=-1){
	    printf("error filling holes in marching cubes\n");
	  }
	  else
	    edges2add[i]=to;
	  printf("missing edge %d %d\n",i,to);
	}
      }
    }
    /*    for(int i=0;i<*nvert;i++){
      int from=i;
      int to;
      int k=0;
      int verti=0;
      int v[6]={-1,-1,-1,-1,-1,-1};
      while((to=edges2add[from])>=0){
	v[verti++]=from;
	if(verti>=6)break;
	edges2add[from]=-1;
	from=to;
      }
      if(verti>=3){
	ensureEnoughPolys(poly,npoly+verti-2,maxpoly);
	for(int j=0;j<verti-2;j++){
	  (*poly)[npoly][0]=v[0];
	  (*poly)[npoly][1]=v[j+1];
	  (*poly)[npoly][2]=v[j+2];
	  printf("Added triangle %d %d %d\n",
		 v[0],v[j+1],v[j+2]);
	  npoly++;
	}
      }
      }*/
    delete edges2add;
    delete edges;

    printf("done %d\n",nbad);
    double * weight = new double[*nvert];
    *norm = new Vec3f[*nvert];
    memset(weight,0,sizeof(int)*(*nvert));
    memset(*norm,0,sizeof(Vec3f)*(*nvert));
    for(int i=0;i<npoly;i++){
      int back=(*poly)[i][0];
      (*poly)[i][0]=(*poly)[i][1];
      (*poly)[i][1]=back;
      
      Vec3f a = (*vert)[(*poly)[i][1]];
      Vec3f b = (*vert)[(*poly)[i][2]];
      a.sub((*vert)[(*poly)[i][0]]);
      b.sub((*vert)[(*poly)[i][0]]);
      Vec3f c=a.cross(b);
      double len=c.normalize();

      Vec3f e0=(*vert)[(*poly)[i][1]]-(*vert)[(*poly)[i][0]];e0.normalize();
      Vec3f e1=(*vert)[(*poly)[i][2]]-(*vert)[(*poly)[i][0]];e1.normalize();
            
      double a0=acos(e0.dot(e1));
      
      e0=(*vert)[(*poly)[i][0]]-(*vert)[(*poly)[i][1]];e0.normalize();
      e1=(*vert)[(*poly)[i][2]]-(*vert)[(*poly)[i][1]];e1.normalize();
      
      double a1=acos(e0.dot(e1));

      weight[(*poly)[i][0]]+=a0;
      weight[(*poly)[i][1]]+=a1;
      weight[(*poly)[i][2]]+=(M_PI-a0-a1);

      (*norm)[(*poly)[i][0]]=(c*a0);
      (*norm)[(*poly)[i][1]]=(c*a1);
      (*norm)[(*poly)[i][2]]=(c*(M_PI-a0-a1));
      //c.print();
    }
    printf("averaging\n");
    for(int i=0;i<*nvert;i++){
      /*
      Vec3f a = (*vert)[i];
      Vec3f center(0.5,0.5,0.5);
      a.sub(center);
      a.normalize();
      (*norm)[i]=a;*/
      //(*norm)[i];
      (*norm)[i].normalize();
    }

    

    delete weight;
    delete vertGrid;
    delete grid;
    return npoly;
}
