#ifndef MC_H
#define MC_H
#include "matrix.h"
#include "vec.h"
typedef int _3ints[3];

class Cubable{
 public:
    virtual int getWidth()=0;
    virtual int getHeight()=0;
    virtual int getDepth()=0;
    virtual int getBoundaryPoint(Vec3f & pt1,Vec3f & pt2,int p1on,int p2on,Vec3f & output)=0;
    virtual int inside(int xi,int yi,int zi)=0;
};

int getIndex(int * comb);
void invMap(int * inv,int * map);
int baseCombination(int comb);
int baseCombination(int * comb);
int setTri(int index,int v1,int v2,int v3);

void marchingCubesTest(Cubable & c,int nraysets);
int marchingCubes(Cubable & c,_3ints ** poly,Vec3f ** vert,int * nvert,Vec3f ** norm,double mindist);

#endif
