#ifndef SP_H
#define SP_H

typedef struct EdgeNode_T
{
	int to;
	double dist;
	struct EdgeNode_T * next;
}EdgeNode;

typedef EdgeNode ** EdgeList;

typedef struct Graph_T
{
	EdgeList edgeList;
	int nvert;
}Graph;

Graph * allocGraph(int nvert);
void graphAddEdge(Graph * g,int from,int to,double cost);
void printGraph(Graph * g);
void freeGraph(Graph * g);

/*
  Returns an allocated pointer to the resulting predecessor
*/
int * getPred();
double * getDistances();

int * getPredParam(int *);
double * getDistancesParam(double *);

/*
	Should be called before any calls to dij
*/
void allocSingleSource(Graph * g);
void initSingleSource(int source,int nv);


/*
	Should be called after the last call to dij
*/
void freeSingleSource();


/*
	Should call allocSingleSource before, and
	freeSingleSource after last call
*/
void dij(Graph * g,int source);


#endif

