#include "globals.h"
#include "simplify.h"
#include "heap.h"

using namespace CapguiGlobals;

typedef struct HE_T{
  int next;
  int v;
  int face;
}HE;

//return 1 on successful add
int simplify_adj(int ** adj,int * adjcnt,int * adjmax,int a,int b)
{
  for(int i=0;i<adjcnt[a];i++){
    if(adj[a][i]==b){
      return 0;//already been added
    }
  }
  if(adjcnt[a]>=adjmax[a]){
    int * a_adj = new int[adjmax[a]+4];
    memcpy(a_adj,adj[a],sizeof(int)*adjmax[a]);
    adjmax[a]+=4;
    delete adj[a];
    adj[a]=a_adj;
  }
  adj[a][adjcnt[a]++]=b;
  
  return 1;
}
//return 1 on successfull add
int simplify_addhe(int ** v2he,int *v2hecnt,int *v2hemax,int vert,int he)
{
  for(int i=0;i<v2hecnt[i];i++){
    if(v2he[vert][i]==he)return 0;
  }
  if(v2hecnt[vert]>=v2hemax[vert]){
    int * vtof = new int[v2hemax[vert]+4];
    memcpy(vtof,v2he[vert],sizeof(int)*v2hemax[vert]);
    v2hemax[vert]+=4;
    delete v2he[vert];
    v2he[vert]=vtof;
  }
  v2he[vert][v2hecnt[vert]++]=he;
  return 1;
}

double getErrorAndPoint(double * Qs,Vec3f *vert,int v1,int v2,double * Q,
			double *pt)
{
  double * Q1=Qs+16*v1;
  double * Q2=Qs+16*v2;
  double Qinv[16];
  double tmp[4];
  double err;

  for(int j=15;j>=0;j--){
    Q[j]=Q1[j]+Q2[j];
  }
  
  
  if(invert(Qinv,Q)<10e-10){
    Vec3f vec=vert[v1];
    double err1,err2;
    pt[0]=vec[0];
    pt[1]=vec[1];
    pt[2]=vec[2];
    pt[3]=1;

    multPoint(tmp,Q,pt);
    err1=tmp[0]*pt[0]+tmp[1]*pt[1]+
      tmp[2]*pt[2]+tmp[3]*pt[3];
    
    vec=vert[v2];
    pt[0]=vec[0];
    pt[1]=vec[1];
    pt[2]=vec[2];
    pt[3]=1;
    memcpy(pt,vec.getData(),sizeof(double)*3);
    multPoint(tmp,Q,pt);
    err2=tmp[0]*pt[0]+tmp[1]*pt[1]+
      tmp[2]*pt[2]+tmp[3]*pt[3];
    
    vec=vert[v1]+vert[v2];
    vec.mult(0.5);
    pt[0]=vec[0];
    pt[1]=vec[1];
    pt[2]=vec[2];
    pt[3]=1;
    multPoint(tmp,Q,pt);
    err=tmp[0]*pt[0]+tmp[1]*pt[1]+
      tmp[2]*pt[2]+tmp[3]*pt[3];

    err=fabs(err);
    return err;
    if(fabs(err2)<fabs(err)){
      err=fabs(err2);
      pt[0]=vert[v2][0];
      pt[1]=vert[v2][1];
      pt[2]=vert[v2][2];
      pt[3]=1; 
    }
    if(fabs(err1)<fabs(err)){
      err=fabs(err1);
      pt[0]=vert[v1][0];
      pt[1]=vert[v1][1];
      pt[2]=vert[v1][2];
      pt[3]=1;
    }
    return err;
  }
  
  memcpy(pt,Qinv+12,sizeof(double)*4);
  // printf("pt[3]=%f\n",pt[3]);
  pt[0]/=pt[3];
  pt[1]/=pt[3];
  pt[2]/=pt[3];
  pt[3]/=pt[3];
  //printf("%f %f %f\n",pt[0],pt[1],pt[2]);
  multPoint(tmp,Q,pt);
  err=tmp[0]*pt[0]+tmp[1]*pt[1]+
    tmp[2]*pt[2]+tmp[3]*pt[3];
  return fabs(err);
}

void simplify(Chart &ch,int percentRemove)
{
    int fuck=0;
    double * Qs;
    int ** adj;
    int * adjmax;
    int * adjcnt;
    int ** v2he;
    int * v2hecnt;
    int * v2hemax;
    int i=0;
    int totalAdj;
    HE *hes;
    Heap * heap;
    int nhe=0;
    
    Qs=new double[16*ch.nvert];
    adj = new int*[ch.nvert];
    adjmax = new int[ch.nvert];
    adjcnt = new int[ch.nvert];
    v2he = new int*[ch.nvert];
    v2hecnt = new int[ch.nvert];
    v2hemax = new int[ch.nvert];
    i=0;
    totalAdj=0;
    hes=new HE[ch.npoly*3];
    nhe=0;
    
    memset(Qs,0,16*sizeof(double)*(ch.nvert));
    memset(adj,0,sizeof(int*)*(ch.nvert));
    memset(adjmax,0,sizeof(int)*(ch.nvert));
    memset(adjcnt,0,sizeof(int)*(ch.nvert));
    memset(v2he,0,sizeof(int *)*(ch.nvert));
    memset(v2hecnt,0,sizeof(int)*(ch.nvert));
    memset(v2hemax,0,sizeof(int)*(ch.nvert));
    //allocate mem for adjacencies
    for(i=0;i<ch.nvert;i++){
      adjmax[i]=6;
      adj[i]=new int[adjmax[i]];
      v2hemax[i]=6;
      v2he[i]=new int[v2hemax[i]];
    }
    printf("allocated adj\n");
    
    //build adjacency and initialize the Q's
    for(i=0;i<ch.npoly;i++){
      totalAdj+=simplify_adj(adj,adjcnt,adjmax,ch.poly[i][0],ch.poly[i][1]);
      totalAdj+=simplify_adj(adj,adjcnt,adjmax,ch.poly[i][1],ch.poly[i][2]);
      totalAdj+=simplify_adj(adj,adjcnt,adjmax,ch.poly[i][0],ch.poly[i][2]);
      
      hes[nhe].v=ch.poly[i][0];
      hes[nhe].next=nhe+1;
      hes[nhe].face=i;
      nhe++;
      
      hes[nhe].v=ch.poly[i][1];
      hes[nhe].next=nhe+1;
      hes[nhe].face=i;
      nhe++;
      
      hes[nhe].v=ch.poly[i][2];
      hes[nhe].next=nhe-2;
      hes[nhe].face=i;
      nhe++;
      
      simplify_addhe(v2he,v2hecnt,v2hemax,(ch.poly)[i][0],nhe-3);
      simplify_addhe(v2he,v2hecnt,v2hemax,(ch.poly)[i][1],nhe-2);
      simplify_addhe(v2he,v2hecnt,v2hemax,(ch.poly)[i][2],nhe-1);
      
      Vec3f e1=ch.vert[ch.poly[i][1]]-ch.vert[ch.poly[i][0]];
      Vec3f e2=ch.vert[ch.poly[i][2]]-ch.vert[ch.poly[i][0]];
      Vec3f abc=e1.cross(e2);
      
      abc.normalize();
      double d = -abc.dot(ch.vert[ch.poly[i][0]]);
      
      double a=abc[0],b=abc[1],c=abc[2];
      
      double Q[]={a*a,a*b,a*c,a*d,
		  b*a,b*b,b*c,b*d,
		  c*a,c*b,c*c,c*d,
		  d*a,d*b,d*c,d*d};
      double * Q0= Qs+ch.poly[i][0]*16;
      double * Q1= Qs+ch.poly[i][1]*16;
      double * Q2= Qs+ch.poly[i][2]*16;
      
      for(int j=0;j<16;j++){
	Q0[j]+=Q[j];
	Q1[j]+=Q[j];
	Q2[j]+=Q[j];
      }
    }
    printf("inited he and Q's\n");
    heap= new Heap(nhe);
    for(i=0;i<nhe;i++){
      int v1=hes[i].v;
      int v2=hes[hes[i].next].v;
      double pt[4];
      double Q[16];
      double err=getErrorAndPoint(Qs,ch.vert,v1,v2,Q,pt);
      heap->insert(i,err);
    }
    printf("inserted into heap\n");
    double err;
    int node;
    int rem=0;
    int maxrem=percentRemove*(ch.nvert)/100;
    printf("heap contains %d %d/%d\n",heap->n,maxrem,nhe);
    while(((node=heap->remove(&err))>=0) && rem<maxrem){
      int v1=hes[node].v;
      int v2=hes[hes[node].next].v;
      double pt[4];
      double Q[16];
      if(v1==v2)continue;
  
      //printf("removing %d, %d %d\n",node,v1,v2);
      //else printf(".");
  
      double errback=err;
      err=getErrorAndPoint(Qs,ch.vert,v1,v2,Q,pt);
  
      //detect flips
      Vec3f vec1 = ch.vert[v2];
      Vec3f vecnew(pt[0],pt[1],pt[2]);
      Vec3f vec2;
      Vec3f vec3;
      int j=0;
  
      for(j=0;j<v2hecnt[v2];j++){
	vec2=ch.vert[hes[hes[v2he[v2][j]].next].v];
	vec3=ch.vert[hes[hes[hes[v2he[v2][j]].next].next].v];
	Vec3f norm=(vec2-vec1).cross(vec3-vec1);
	Vec3f normnew=(vec2-vecnew).cross(vec3-vecnew);
	if(hes[hes[hes[hes[v2he[v2][j]].next].next].next].v
	   !=v2){
	  printf("bad triangle %d %d %d\n",
		 hes[hes[v2he[v2][j]].next].v,
		 hes[hes[hes[v2he[v2][j]].next].next].v,
		 hes[hes[hes[hes[v2he[v2][j]].next].next].next].v);
	  continue;
	}
	norm.normalize();
	normnew.normalize();
	if(norm.dot(normnew)<0.0){
	  break;
	}
	/*	    Vec3f e1=(vec2-vecnew);
		    Vec3f e2=(vec3-vecnew);
		    Vec3f e3=(vec2-vec3);
		    e1.normalize();e2.normalize();
		    double d1=acos(e1.dot(e2));
		    double d2=acos(e1.dot(e3));
		    if(d1>0.99*M_PI || d1<0.01*M_PI ||
		    d2>0.99*M_PI || d2<0.01*M_PI ){
		    //printf("angle is bad %f %f\n",d1*180.0/M_PI,d2*180.0/M_PI);
		    break;
		    }*/
      }
      if(j!=v2hecnt[v2]){
	continue;
      }
  
      vec1 = ch.vert[v1];
      for(j=0;j<v2hecnt[v1];j++){
	vec2=ch.vert[hes[hes[v2he[v1][j]].next].v];
	vec3=ch.vert[hes[hes[hes[v2he[v1][j]].next].next].v];
	Vec3f norm=(vec2-vec1).cross(vec3-vec1);
	Vec3f normnew=(vec2-vecnew).cross(vec3-vecnew);
	if(hes[hes[hes[hes[v2he[v1][j]].next].next].next].v
	   !=v1){
	  printf("bad triangle %d %d %d\n",
		 hes[hes[v2he[v1][j]].next].v,
		 hes[hes[hes[v2he[v1][j]].next].next].v,
		 hes[hes[hes[hes[v2he[v1][j]].next].next].next].v);
	  continue;
	}
	norm.normalize();
	normnew.normalize();
	if(norm.dot(normnew)<0.0){
	  //printf("flipper\n");
	  break;
	}/*
	   Vec3f e1=(vec2-vecnew);
	   Vec3f e2=(vec3-vecnew);
	   Vec3f e3=(vec2-vec3);
	   e1.normalize();e2.normalize();
	   double d1=acos(e1.dot(e2));
	   double d2=acos(e1.dot(e3));
	   if(d1>0.99*M_PI || d1<0.01*M_PI ||
	   d2>0.99*M_PI || d2<0.01*M_PI ){
	   //printf("angle is bad %f %f\n",d1*180.0/M_PI,d2*180.0/M_PI);
	   break;
	   }*/
      }
      if(j!=v2hecnt[v1]){
	continue;
      }


      memcpy(Qs+16*v1,Q,sizeof(double)*16);
      ch.vert[v1][0]=pt[0];
      ch.vert[v1][1]=pt[1];
      ch.vert[v1][2]=pt[2];
	
      //printf("updating he %d\n",v2hecnt[v2]);
      for(i=0;i<v2hecnt[v2];i++){
	int hei=v2he[v2][i];
	    
	if(hes[hei].v==v2){
	  hes[hei].v=v1;
	  simplify_addhe(v2he,v2hecnt,v2hemax,v1,hei);
	}
	int face=hes[hei].face;
	for(int j=0;j<3;j++){
	  if(ch.poly[face][j]==v2){
	    ch.poly[face][j]=v1;
	  }
	}
      }
	
      for(i=0;i<v2hecnt[v1];i++){
	int hei=v2he[v1][i];

	err=getErrorAndPoint(Qs,ch.vert,
			     hes[hei].v,
			     hes[hes[hei].next].v,Q,pt);

	if(heap->exists(hei))
	  heap->update(hei,err,1);
	    
	//update the previous...
	err=getErrorAndPoint(Qs,ch.vert,
			     hes[hes[hei].next].v,
			     hes[hes[hes[hei].next].next].v,Q,pt);

	if(heap->exists(hes[hei].next))
	  heap->update(hes[hei].next,err,1);
      }
	
      rem++;
      if(rem%100==0){
	printf("removed %d of %d\n",rem,ch.nvert);
      }
    }
    
    /*//clean up
      heap->removeAll();
      for(i=0;i<*nvert;i++){
      delete adj[i];
      delete v2he[i];
      }
      delete v2he;
      delete adj;
      delete adjmax;
      delete adjcnt;
      delete v2hecnt;
      delete v2hemax;
      delete hes;*/
    int nnewvert=0;
    int nnewpoly=0;
    int * map = new int[ch.nvert];
    memset(map,0xff,sizeof(int)*(ch.nvert));
    for(int i=0;i<ch.npoly;i++){
      if((ch.poly)[i][0]==(ch.poly)[i][1] ||
	 (ch.poly)[i][1]==(ch.poly)[i][2] ||
	 (ch.poly)[i][2]==(ch.poly)[i][0]){
      }
      else{
	nnewpoly++;
	if(map[(ch.poly)[i][0]]<0){
	  map[(ch.poly)[i][0]]=nnewvert;
	  nnewvert++;
	}
	if(map[(ch.poly)[i][1]]<0){
	  map[(ch.poly)[i][1]]=nnewvert;
	  nnewvert++;
	}
	if(map[(ch.poly)[i][2]]<0){
	  map[(ch.poly)[i][2]]=nnewvert;
	  nnewvert++;
	}
      }
    }
    
    Chart newch;
    newch.init(nnewpoly,nnewvert);
    nnewpoly=0;
    
    for(int i=0;i<ch.npoly;i++){
      if((ch.poly)[i][0]==(ch.poly)[i][1] ||
	 (ch.poly)[i][1]==(ch.poly)[i][2] ||
	 (ch.poly)[i][2]==(ch.poly)[i][0]){
      }
      else{
	newch.vert[map[ch.poly[i][0]]]=ch.vert[ch.poly[i][0]];
	newch.poly[nnewpoly][0]=map[ch.poly[i][0]];
	newch.vert[map[ch.poly[i][1]]]=ch.vert[ch.poly[i][1]];
	newch.poly[nnewpoly][1]=map[ch.poly[i][1]];
	newch.vert[map[ch.poly[i][2]]]=ch.vert[ch.poly[i][2]];
	newch.poly[nnewpoly][2]=map[ch.poly[i][2]];
	nnewpoly++;
      }
    }
    newch.initNormals();
    delete map;
    ch.release();
    ch=newch;
}


