#ifndef TIMER_H
#define TIMER_H
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

class Timer{
  int started;
#ifdef WIN32
  DWORD startTime;
#else
  struct timeval startTime;
#endif
 public:
  Timer(){
    started=0;
#ifndef WIN32
    startTime.tv_usec=0;
    startTime.tv_sec=0;
#else
    startTime=0;
#endif
 }
#ifdef WIN32
  void getTime(DWORD *t){
    *(t)=GetTickCount();
  }
#else
  void getTime(struct timeval * t){
    gettimeofday(t,0);
  }
#endif
#ifdef WIN32
  DWORD getTime(){
    return GetTickCount();
  }
#else
  struct timeval getTime(){
    struct timeval t;
    gettimeofday(&t,0);
    return t;
  }
#endif
  void start(){
    getTime(&startTime);
    started=1;
  }
  int getStarted(){
    return started;
  }
  double getElapsedTime(){
    if(!started)return 0;
#ifdef WIN32
    DWORD etime;
    getTime(&etime);
    return (((double)etime)-((double)startTime))/1000.0;
#else
    struct timeval etime;
    getTime(&etime);
    /*printf("%ld-%ld=%ld",etime.tv_sec, startTime.tv_sec,
	   etime.tv_sec-startTime.tv_sec);
    printf("%ld-%ld=%ld",etime.tv_usec, startTime.tv_usec,
    etime.tv_usec-startTime.tv_usec);*/
    double esec=(etime.tv_sec-startTime.tv_sec)+
      (double)(etime.tv_usec-startTime.tv_usec)/1e6;
    return esec;
#endif
  }
  double stop(){
    double esec=getElapsedTime();
    started=0;
    return esec;
  }
};

#endif
